CMR
CMR The following routines are part of the Dalton system (see below) !!!
CMR They have been adjusted by M. Reiher in June 2003 for SNF/VROA calculations
CMR with permission of K. Ruud, U Troms, Norway
CMR

C
C...   Copyright (c) 2001 by the authors of Dalton (see below).
C...   All Rights Reserved.
C...
C...   The source code in this file is part of
C...   "Dalton, a molecular electronic structure program, Release 1.2
C...   (2001), written by T. Helgaker, H. J. Aa. Jensen, P. Joergensen,
C...   J. Olsen, K. Ruud, H. Aagren, A.A. Auer, K.L. Bak, V. Bakken,
C...   O. Christiansen, S. Coriani, P. Dahle, E. K. Dalskov,
C...   T. Enevoldsen, B. Fernandez, C. Haettig, K. Hald, A. Halkier,
C...   H. Heiberg, H. Hettema, D. Jonsson, S. Kirpekar, R. Kobayashi,
C...   H. Koch, K. V. Mikkelsen, P. Norman, M. J. Packer,
C...   T. B. Pedersen, T. A. Ruden, A. Sanchez, T. Saue, S. P. A. Sauer,
C...   B. Schimmelpfennig, K. O. Sylvester-Hvid, P. R. Taylor,
C...   and O. Vahtras"
C...
C...   This source code is provided under a written licence and may be
C...   used, copied, transmitted, or stored only in accord with that
C...   written licence.
C...
C...   In particular, no part of the source code or compiled modules may
C...   be distributed outside the research group of the licence holder.
C...   This means also that persons (e.g. post-docs) leaving the research
C...   group of the licence holder may not take any part of Dalton,
C...   including modified files, with him/her, unless that person has
C...   obtained his/her own licence.
C...
C...   For questions concerning this copyright write to:
C...      dalton-admin@kjemi.uio.no
C...
C...   For information on how to get a licence see:
C...      http://www.kjemi.uio.no/software/dalton/dalton.html
C

CMR
CMR
CMR The following part was taken from: abalnr.F of DALTON's ABACUS
CMR
CMR

C  /* Deck betagm */
      FUNCTION BETAGM(ALFA,GM)
C
C Calculate Beta(G')**2 =
C BETAGM = 0.5*(3*ALFA(I,J)*GM(I,J) - ALFA(I,I)*GM(J,J))
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
      PARAMETER ( D0 = 0.0D0  , DP5 = 0.5D0 , D3 = 3.0D0 )
      DIMENSION ALFA(3,3),GM(3,3)
C
      BETAGM = D0
      DO 100 I = 1,3
         DO 200 J = 1,3
            BETAGM = BETAGM +
     &               DP5*(D3*ALFA(I,J)*GM(I,J)-ALFA(I,I)*GM(J,J))
 200     CONTINUE
 100  CONTINUE
C
      RETURN
      END
C  /* Deck betaal */
      FUNCTION BETAAL(ALFA)
C
C Calculate Beta(alfa)**2 =
C BETAAL =  0.5 * (3*ALFA(I,J)*ALFA(I,J) - ALFA(I,I)*ALFA(J,J))
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
      PARAMETER ( D0 = 0.0D0  , DP5 = 0.5D0 , D3 = 3.0D0 )
      DIMENSION ALFA(3,3)
C
      BETAAL = D0
      DO 100 I = 1,3
         DO 200 J = 1,3
            BETAAL = BETAAL + DP5*(D3*ALFA(I,J)*ALFA(I,J)
     *                             -ALFA(I,I)*ALFA(J,J))
 200     CONTINUE
 100  CONTINUE
C
      RETURN
      END
C  /* Deck betaa */
      FUNCTION BETAA(ALFA,A,OMEGA)
C
C Calculate Beta(A)**2 =
C BETAA =  0.5*OMEGA*ALFA(I,J)*EPSILON(I,K,L)*A(K,L,J)
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
      PARAMETER ( D0 = 0.0D0 , DP5 = 0.5D0 , D1 = 1.0D0 , DM1 = -1.0D0)
      DIMENSION ALFA(3,3), A(3,3,3)
      DIMENSION EPSILO(3,3,3)
      DATA EPSILO / D0, D0,  D0, D0, D0, DM1, D0,  D1, D0,
     &              D0, D0,  D1, D0, D0, D0,  DM1, D0, D0,
     &              D0, DM1, D0, D1, D0, D0,  D0,  D0, D0/
C
      BETAA = D0
      DO 100 I = 1,3
         DO 200 J = 1,3
            DO 300 K = 1,3
               DO 400 L = 1,3
                  BETAA = BETAA + DP5*OMEGA*ALFA(I,J)*EPSILO(I,K,L)*
     *                                A(K,L,J)
 400           CONTINUE
 300        CONTINUE
 200     CONTINUE
 100  CONTINUE
C
      RETURN
      END
C  /* Deck alfmn */
      FUNCTION ALFMN(ALFA)
C
C Calculate AlfaMean =  ALFMN = ( (1/3) * ALFA(I,I) )
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
      PARAMETER ( D0 = 0.0D0, D3 = 3.0D0 )
      DIMENSION ALFA(3,3)
C
      ALFMN = D0
      DO 100 I = 1,3
         ALFMN = ALFMN + ALFA(I,I)
 100  CONTINUE
C
      ALFMN = ALFMN  / D3
C
      RETURN
      END
C  /* Deck gmmn */
      FUNCTION GMMN(GM)
C
C Calculate G' =  GMMN = ( (1/3) * GM(I,I) )
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
      PARAMETER ( D0 = 0.0D0, D3 = 3.0D0 )
      DIMENSION GM(3,3)
C
      GMMN = D0
      DO 100 I = 1,3
         GMMN = GMMN + GM(I,I)
 100  CONTINUE
C
      GMMN = GMMN  / D3
C
      RETURN
      END
C  /* Deck raminl */
      FUNCTION RAMINL(ALFMN,BETAAL)
C
C Calculate RamanIntensity =  RAMIN = (45 * ALFMN**2) + (4 * BETA**2)
C for linear pol. incident radiation perpendicular to scattering plane
C 
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
      PARAMETER ( D0 = 0.0D0, D4 = 4.0D0, D45 = 45.0D0 )
C
      RAMINL = (D45 * ALFMN**2) + (D4 * BETAAL)
C
      RETURN
      END
C  /* Deck depoll */
      FUNCTION DEPOLL(ALFMN,BETAAL)
C
C Calculate the Depolarization Ratio for rightangle scattering,
C linear polarized incident light, perpendicular (=parall/perpend)
C plane = DEPOLR = (3 * BETA**2) / (45 * ALFMN**2 + 4 * BETA**2)
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
      PARAMETER ( D0 = 0.0D0, D3 = 3.0D0, D4 = 4.0D0, D45 = 45.0D0 )
C
      A      = D3 * BETAAL
      B      = (D45 * ALFMN**2) + (D4 * BETAAL)
C
      IF ( B .GT. 0.D-6 ) THEN
         DEPOLL = A / B
      ELSE
         DEPOLL = D0
      ENDIF
C
      RETURN
      END
C  /* Deck raminn */
      FUNCTION RAMINN(ALFMN,BETAAL)
C
C Calculate RamanIntensity =  RAMIN = (45 * ALFMN**2) + (7 * BETA**2)
C for natural & circular pol. incident radiation 
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
      PARAMETER ( D0 = 0.0D0, D7 = 7.0D0, D45 = 45.0D0 )
C
      RAMINN = (D45 * ALFMN**2) + (D7 * BETAAL)
C
      RETURN
      END
C  /* Deck depoln */
      FUNCTION DEPOLN(ALFMN,BETAAL)
C
C Calculate the Depolarization Ratio for rightangle scattering, 
C natural or circ. pol. incident light (=parall/perpend).
C plane = DEPOLR = (6 * BETA**2) / (45 * ALFMN**2 + 7 * BETA**2)
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
      PARAMETER ( D0 = 0.0D0, D6 = 6.0D0, D7 = 7.0D0, D45 = 45.0D0 )
C
      A      = D6 * BETAAL
      B      = (D45 * ALFMN**2) + (D7 * BETAAL)
C
      IF ( B .GT. 0.D-6 ) THEN
         DEPOLN = A / B
      ELSE
         DEPOLN = D0
      ENDIF
C
      RETURN
      END
C  /* Deck deltaz */
      FUNCTION DELTAZ(BETAGM,BETAA)
C
C Calculate the difference differential scattering cross section  
C in depolarized rightangle scattering =
C DELTAZ = 4/c ( 6*BETAGM - 2*BETAA)
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
CMR
CMR#include <codata.h>
C
C  codata.h revised 1999/04/29 and combined with units.h
C
C
C  From
C  "CODATA Recommended Values of the Fundamental Physical Constants: 1998"
C                     Peter J. Mohr and Barry N. Taylor
C  Journal of Physical and Chemical Reference Data, Vol. 28, No. 6, 1999
C
C -- Fundamental constants, atomic units, Avogadro's constant
C
C$Id: alphac.h,v 1.1.1.1 2001/02/08 13:33:27 hjj Exp $
C
C
C     Fine structure constant
C
      PARAMETER (CVEL = 137.0359895D0, ALPHAC = 1.0D0/CVEL,
     &                               ALPHA2 = ALPHAC*ALPHAC)
C
      PARAMETER ( XTANG = 0.529 177 2083 D0, XFAMU  = 1822.88848 D0,
     &            ECHARGE = 1.602 176 462D-19, HBAR = 1.054 571 60D-34)
      PARAMETER ( XFMOL = 6.022 141 99 D23 )
C -- conversion from hartree (au) to:
      PARAMETER ( XTJ  = 4.359 743 81 D-18,  XTKAYS = 219474.6313710D0,
     *            XTHZ = 6.579 683 920 735 D15, XTEV = 27.211 3834 D0,
     &            XKJMOL = XTJ*XFMOL*1.D-3, XKCMOL = XKJMOL/4.184 D0,
     &            XTKJML = XKJMOL,          XTKCML = XKCMOL,
     *            XTNM = 1.D7/XTKAYS,       XAJOUL = 1.0 D18*XTJ)
C
C -- other
      PARAMETER ( AUTIME = HBAR/XTJ, XFSEC = AUTIME)
      PARAMETER ( XTKMML = 974.864 D0)
      PARAMETER ( TESLA=(XTANG*XTANG*ECHARGE/HBAR)*1.D-20 )
      PARAMETER ( AUTK = 3.157 7465 D5 )
CMR end of <codata.h>
CMR
      PARAMETER ( D2 = 2.0D0, D4 = 4.0D0, D6 = 6.0D0 )
C
      DELTAZ = D4 / CVEL * (D6 * BETAGM - D2 * BETAA)
C
      RETURN
      END
C  /* Deck deltax */
      FUNCTION DELTAX(BETAGM,BETAA,ALFAMN,GMMN)
C
C Calculate the difference differential scattering cross section
C in polarized rightangle scattering =
C DELTAX = 4/c ( 45*ALFAMN*GMMN+7*BETAGM+BETAA)
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
CMR
CMR#include <codata.h>
C
C  codata.h revised 1999/04/29 and combined with units.h
C
C
C  From
C  "CODATA Recommended Values of the Fundamental Physical Constants: 1998"
C                     Peter J. Mohr and Barry N. Taylor
C  Journal of Physical and Chemical Reference Data, Vol. 28, No. 6, 1999
C  
C -- Fundamental constants, atomic units, Avogadro's constant
C
C$Id: alphac.h,v 1.1.1.1 2001/02/08 13:33:27 hjj Exp $
C 
C 
C     Fine structure constant
C
      PARAMETER (CVEL = 137.0359895D0, ALPHAC = 1.0D0/CVEL,
     &                               ALPHA2 = ALPHAC*ALPHAC)
C
      PARAMETER ( XTANG = 0.529 177 2083 D0, XFAMU  = 1822.88848 D0,
     &            ECHARGE = 1.602 176 462D-19, HBAR = 1.054 571 60D-34)
      PARAMETER ( XFMOL = 6.022 141 99 D23 )
C -- conversion from hartree (au) to:
      PARAMETER ( XTJ  = 4.359 743 81 D-18,  XTKAYS = 219474.6313710D0,
     *            XTHZ = 6.579 683 920 735 D15, XTEV = 27.211 3834 D0,
     &            XKJMOL = XTJ*XFMOL*1.D-3, XKCMOL = XKJMOL/4.184 D0,
     &            XTKJML = XKJMOL,          XTKCML = XKCMOL,
     *            XTNM = 1.D7/XTKAYS,       XAJOUL = 1.0 D18*XTJ)
C
C -- other
      PARAMETER ( AUTIME = HBAR/XTJ, XFSEC = AUTIME)
      PARAMETER ( XTKMML = 974.864 D0)
      PARAMETER ( TESLA=(XTANG*XTANG*ECHARGE/HBAR)*1.D-20 )
      PARAMETER ( AUTK = 3.157 7465 D5 )
CMR end of <codata.h>
CMR
      PARAMETER ( D4 = 4.0D0, D7 = 7.0D0, D45 = 45.0D0)
C
      DELTAX = D4 / CVEL * (D45*ALFAMN*GMMN+D7*BETAGM+BETAA)
C
      RETURN
      END
C  /* Deck delta0 */
      FUNCTION DELTA0(BETAGM,BETAA,ALFAMN,GMMN)
C
C Calculate the difference differential scattering cross section
C in forward scattering with no analyzer =
C DELTA0 = 4/c (180*ALFAMN*GMMN+4*BETAGM-4*BETAA)
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
CMR
CMR#include <codata.h>
C
C  codata.h revised 1999/04/29 and combined with units.h
C
C
C  From
C  "CODATA Recommended Values of the Fundamental Physical Constants: 1998"
C                     Peter J. Mohr and Barry N. Taylor
C  Journal of Physical and Chemical Reference Data, Vol. 28, No. 6, 1999
C  
C -- Fundamental constants, atomic units, Avogadro's constant
C
C$Id: alphac.h,v 1.1.1.1 2001/02/08 13:33:27 hjj Exp $
C 
C 
C     Fine structure constant
C
      PARAMETER (CVEL = 137.0359895D0, ALPHAC = 1.0D0/CVEL,
     &                               ALPHA2 = ALPHAC*ALPHAC)
C
      PARAMETER ( XTANG = 0.529 177 2083 D0, XFAMU  = 1822.88848 D0,
     &            ECHARGE = 1.602 176 462D-19, HBAR = 1.054 571 60D-34)
      PARAMETER ( XFMOL = 6.022 141 99 D23 )
C -- conversion from hartree (au) to:
      PARAMETER ( XTJ  = 4.359 743 81 D-18,  XTKAYS = 219474.6313710D0,
     *            XTHZ = 6.579 683 920 735 D15, XTEV = 27.211 3834 D0,
     &            XKJMOL = XTJ*XFMOL*1.D-3, XKCMOL = XKJMOL/4.184 D0,
     &            XTKJML = XKJMOL,          XTKCML = XKCMOL,
     *            XTNM = 1.D7/XTKAYS,       XAJOUL = 1.0 D18*XTJ)
C
C -- other
      PARAMETER ( AUTIME = HBAR/XTJ, XFSEC = AUTIME)
      PARAMETER ( XTKMML = 974.864 D0)
      PARAMETER ( TESLA=(XTANG*XTANG*ECHARGE/HBAR)*1.D-20 )
      PARAMETER ( AUTK = 3.157 7465 D5 )
CMR end of <codata.h>
CMR
      PARAMETER ( D4 = 4.0D0, D180 = 18.0D1 )
C
      DELTA0 = D4 / CVEL * (D180*ALFAMN*GMMN+D4*BETAGM-D4*BETAA)
C
      RETURN
      END
C  /* Deck deltab */
      FUNCTION DELTAB(BETAGM,BETAA)
C
C Calculate the difference differential scattering cross section
C in backward scattering with no analyzer =
C DELTAB = 4/c ( 24*BETAGM+8*BETAA)
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
CMR
CMR#include <codata.h>
C
C  codata.h revised 1999/04/29 and combined with units.h
C
C
C  From
C  "CODATA Recommended Values of the Fundamental Physical Constants: 1998"
C                     Peter J. Mohr and Barry N. Taylor
C  Journal of Physical and Chemical Reference Data, Vol. 28, No. 6, 1999
C  
C -- Fundamental constants, atomic units, Avogadro's constant
C
C$Id: alphac.h,v 1.1.1.1 2001/02/08 13:33:27 hjj Exp $
C 
C 
C     Fine structure constant
C
      PARAMETER (CVEL = 137.0359895D0, ALPHAC = 1.0D0/CVEL,
     &                               ALPHA2 = ALPHAC*ALPHAC)
C
      PARAMETER ( XTANG = 0.529 177 2083 D0, XFAMU  = 1822.88848 D0,
     &            ECHARGE = 1.602 176 462D-19, HBAR = 1.054 571 60D-34)
      PARAMETER ( XFMOL = 6.022 141 99 D23 )
C -- conversion from hartree (au) to:
      PARAMETER ( XTJ  = 4.359 743 81 D-18,  XTKAYS = 219474.6313710D0,
     *            XTHZ = 6.579 683 920 735 D15, XTEV = 27.211 3834 D0,
     &            XKJMOL = XTJ*XFMOL*1.D-3, XKCMOL = XKJMOL/4.184 D0,
     &            XTKJML = XKJMOL,          XTKCML = XKCMOL,
     *            XTNM = 1.D7/XTKAYS,       XAJOUL = 1.0 D18*XTJ)
C
C -- other
      PARAMETER ( AUTIME = HBAR/XTJ, XFSEC = AUTIME)
      PARAMETER ( XTKMML = 974.864 D0)
      PARAMETER ( TESLA=(XTANG*XTANG*ECHARGE/HBAR)*1.D-20 )
      PARAMETER ( AUTK = 3.157 7465 D5 )
CMR end of <codata.h>
CMR
      PARAMETER ( D4 = 4.0D0, D8 = 8.0D0, D24 = 24.0D0 )
C
      DELTAB = D4 / CVEL * (D24*BETAGM + D8*BETAA)
C
      RETURN
      END
C  /* Deck cid */
      FUNCTION CID(DELTA,RMINN)
C
C Calculate the Circular Intensity Difference (CID) for all
C arragements. CID = - DELTA  / (2*RMINN)
C RMIN(0) and (180) with no analyzer = 2*RMIN.
C Rmin (depolarized) = DEPLN * RMINN
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
C
      PARAMETER ( D0 = 0.0D0, DP5 = 0.5D0 )
C
      IF ( RMINN .GT. 0.D-6 ) THEN
         CID = DELTA / RMINN * DP5
      ELSE
         CID = D0
      ENDIF
C
      RETURN
      END
C  /* Deck boltzk */
      FUNCTION BOLTZK(FREQ)
C
C Calculate the Boltzmannfactor for Spectra simulation 
C BOLTZK = 1/(1-EXP(-h*freq/k/T)), FREQ is in Hartree = 2Pi*freq
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
CMR
CMR#include <codata.h>
C
C  codata.h revised 1999/04/29 and combined with units.h
C
C
C  From
C  "CODATA Recommended Values of the Fundamental Physical Constants: 1998"
C                     Peter J. Mohr and Barry N. Taylor
C  Journal of Physical and Chemical Reference Data, Vol. 28, No. 6, 1999
C  
C -- Fundamental constants, atomic units, Avogadro's constant
C
C$Id: alphac.h,v 1.1.1.1 2001/02/08 13:33:27 hjj Exp $
C 
C 
C     Fine structure constant
C
      PARAMETER (CVEL = 137.0359895D0, ALPHAC = 1.0D0/CVEL,
     &                               ALPHA2 = ALPHAC*ALPHAC)
C
      PARAMETER ( XTANG = 0.529 177 2083 D0, XFAMU  = 1822.88848 D0,
     &            ECHARGE = 1.602 176 462D-19, HBAR = 1.054 571 60D-34)
      PARAMETER ( XFMOL = 6.022 141 99 D23 )
C -- conversion from hartree (au) to:
      PARAMETER ( XTJ  = 4.359 743 81 D-18,  XTKAYS = 219474.6313710D0,
     *            XTHZ = 6.579 683 920 735 D15, XTEV = 27.211 3834 D0,
     &            XKJMOL = XTJ*XFMOL*1.D-3, XKCMOL = XKJMOL/4.184 D0,
     &            XTKJML = XKJMOL,          XTKCML = XKCMOL,
     *            XTNM = 1.D7/XTKAYS,       XAJOUL = 1.0 D18*XTJ)
C
C -- other
      PARAMETER ( AUTIME = HBAR/XTJ, XFSEC = AUTIME)
      PARAMETER ( XTKMML = 974.864 D0)
      PARAMETER ( TESLA=(XTANG*XTANG*ECHARGE/HBAR)*1.D-20 )
      PARAMETER ( AUTK = 3.157 7465 D5 )
CMR end of <codata.h>
CMR
      PARAMETER ( TSTAND = 298.15D0 )
C
      BOLTZK = 1-EXP(-(FREQ*AUTK)/TSTAND)
      RETURN
      END
C  /* Deck crossk */
      FUNCTION CROSSK(FRVAL,FREQ)
C
C Calculate the Constant for the differential scattering cross section
C K = 16/90*Pi**4*((freq0-freq)/C)**3*freq0/C
C Combined with the freq. factor out of PLACZEK approximation
C B = SQRT(1/(4Pi*freq))
C CROSSK = K*B**2
C ****************** FREQ is in Hartree = 2Pi*freq
C
CMR
CMR#include <implicit.h>
      IMPLICIT REAL*8 (A-H,O-Z)
CMRend of <implicit.h>
CMR
CMR
CMR#include <codata.h>
C
C  codata.h revised 1999/04/29 and combined with units.h
C
C
C  From
C  "CODATA Recommended Values of the Fundamental Physical Constants: 1998"
C                     Peter J. Mohr and Barry N. Taylor
C  Journal of Physical and Chemical Reference Data, Vol. 28, No. 6, 1999
C  
C -- Fundamental constants, atomic units, Avogadro's constant
C
C$Id: alphac.h,v 1.1.1.1 2001/02/08 13:33:27 hjj Exp $
C 
C 
C     Fine structure constant
C
      PARAMETER (CVEL = 137.0359895D0, ALPHAC = 1.0D0/CVEL,
     &                               ALPHA2 = ALPHAC*ALPHAC)
C
      PARAMETER ( XTANG = 0.529 177 2083 D0, XFAMU  = 1822.88848 D0,
     &            ECHARGE = 1.602 176 462D-19, HBAR = 1.054 571 60D-34)
      PARAMETER ( XFMOL = 6.022 141 99 D23 )
C -- conversion from hartree (au) to:
      PARAMETER ( XTJ  = 4.359 743 81 D-18,  XTKAYS = 219474.6313710D0,
     *            XTHZ = 6.579 683 920 735 D15, XTEV = 27.211 3834 D0,
     &            XKJMOL = XTJ*XFMOL*1.D-3, XKCMOL = XKJMOL/4.184 D0,
     &            XTKJML = XKJMOL,          XTKCML = XKCMOL,
     *            XTNM = 1.D7/XTKAYS,       XAJOUL = 1.0 D18*XTJ)
C
C -- other
      PARAMETER ( AUTIME = HBAR/XTJ, XFSEC = AUTIME)
      PARAMETER ( XTKMML = 974.864 D0)
      PARAMETER ( TESLA=(XTANG*XTANG*ECHARGE/HBAR)*1.D-20 )
      PARAMETER ( AUTK = 3.157 7465 D5 )
CMR end of <codata.h>
CMR
      PARAMETER ( D180 = 18.0D1)
C
      CROSSK = (FRVAL-FREQ)**3*FRVAL/FREQ/D180/CVEL**3
      RETURN
      END

CMR
CMR
CMR The following part was taken from: abavib.F of DALTON's ABACUS
CMR
CMR

C
C...   Copyright (c) 2001 by the authors of Dalton (see below).
C...   All Rights Reserved.
C...
C...   The source code in this file is part of
C...   "Dalton, a molecular electronic structure program, Release 1.2
C...   (2001), written by T. Helgaker, H. J. Aa. Jensen, P. Joergensen,
C...   J. Olsen, K. Ruud, H. Aagren, A.A. Auer, K.L. Bak, V. Bakken,
C...   O. Christiansen, S. Coriani, P. Dahle, E. K. Dalskov,
C...   T. Enevoldsen, B. Fernandez, C. Haettig, K. Hald, A. Halkier,
C...   H. Heiberg, H. Hettema, D. Jonsson, S. Kirpekar, R. Kobayashi,
C...   H. Koch, K. V. Mikkelsen, P. Norman, M. J. Packer,
C...   T. B. Pedersen, T. A. Ruden, A. Sanchez, T. Saue, S. P. A. Sauer,
C...   B. Schimmelpfennig, K. O. Sylvester-Hvid, P. R. Taylor,
C...   and O. Vahtras"
C...
C...   This source code is provided under a written licence and may be
C...   used, copied, transmitted, or stored only in accord with that
C...   written licence.
C...
C...   In particular, no part of the source code or compiled modules may
C...   be distributed outside the research group of the licence holder.
C...   This means also that persons (e.g. post-docs) leaving the research
C...   group of the licence holder may not take any part of Dalton,
C...   including modified files, with him/her, unless that person has
C...   obtained his/her own licence.
C...
C...   For questions concerning this copyright write to:
C...      dalton-admin@kjemi.uio.no
C...
C...   For information on how to get a licence see:
C...      http://www.kjemi.uio.no/software/dalton/dalton.html
C
C  /* Deck vibro1_mod */
      SUBROUTINE VIBRO1_MOD(NFRVAL,MXFR,FREQ,ROAAFQ,ROAGNQ,ROAGLQ,ROAAQ,
     &                  BAL,ALMN,CONVER,BOLTZ,NCORD,NUMMOD,FRVAL,LUPRI,
     &                  BGML,BGMNL,BA,DZL,DZNL,
     &                  DXL,DXNL,D0L,D0NL,DBL,DBNL,
     &                  GMMNL,GMMNNL,RMINN,DPOLN,CZL,CZNL,CXL,CXNL,
     &                  C0L,C0NL,CBL,CBNL)
C
C     This subroutine is essentially the VROA part of VIBRO1 from
C       the DALTON package.
C
C     adjusted by M. Reiher for SNF in June 2003 
C
CMR
CMR#include <codata.h>
C
C  codata.h revised 1999/04/29 and combined with units.h
C
C
C  From
C  "CODATA Recommended Values of the Fundamental Physical Constants: 1998"
C                     Peter J. Mohr and Barry N. Taylor
C  Journal of Physical and Chemical Reference Data, Vol. 28, No. 6, 1999
C  
C -- Fundamental constants, atomic units, Avogadro's constant
C
C$Id: alphac.h,v 1.1.1.1 2001/02/08 13:33:27 hjj Exp $
C 
C 
C     Fine structure constant
C
      PARAMETER (CVEL = 137.0359895D0, ALPHAC = 1.0D0/CVEL,
     &                               ALPHA2 = ALPHAC*ALPHAC)
C
      PARAMETER ( XTANG = 0.529 177 2083 D0, XFAMU  = 1822.88848 D0,
     &            ECHARGE = 1.602 176 462D-19, HBAR = 1.054 571 60D-34)
      PARAMETER ( XFMOL = 6.022 141 99 D23 )
C -- conversion from hartree (au) to:
      PARAMETER ( XTJ  = 4.359 743 81 D-18,  XTKAYS = 219474.6313710D0,
     *            XTHZ = 6.579 683 920 735 D15, XTEV = 27.211 3834 D0,
     &            XKJMOL = XTJ*XFMOL*1.D-3, XKCMOL = XKJMOL/4.184 D0,
     &            XTKJML = XKJMOL,          XTKCML = XKCMOL,
     *            XTNM = 1.D7/XTKAYS,       XAJOUL = 1.0 D18*XTJ)
C
C -- other
      PARAMETER ( AUTIME = HBAR/XTJ, XFSEC = AUTIME)
      PARAMETER ( XTKMML = 974.864 D0)
      PARAMETER ( TESLA=(XTANG*XTANG*ECHARGE/HBAR)*1.D-20 )
      PARAMETER ( AUTK = 3.157 7465 D5 )
CMR end of <codata.h>
CMR
      INTEGER F,NFRVAL,MXFR,K,L,M
      PARAMETER (DE3=1.0D3,DE13 = 1.0D13, D2=2.0D0, DE6=1.0D6 ) 
C Conversion factors from au to derivated cgs
      PARAMETER (XFOAIN = ALPHAC*XTANG**4*XFAMU*DE6,
     &           XFRAIN = XTANG**4*XFAMU,
     &           XFCONV = 1/(XTANG**2*XFAMU)*DE13)
      REAL*8 ROAAFQ(3,3,NFRVAL,NCORD), ROAGNQ(3,3,NFRVAL,NCORD),
     &          ROAGLQ(3,3,NFRVAL,NCORD), ROAAQ(3,3,3,NFRVAL,NCORD),
     &          BAL(NCORD), BGML(NCORD), BGMNL(NCORD), BA(NCORD),
     &          ALMN(NCORD), GMMNL(NCORD), GMMNNL(NCORD),
     &          RMINN(NCORD),DPOLN(NCORD), DZL(NCORD),
     &          DZNL(NCORD), FREQ(*), DXL(NCORD),FRVAL(NFRVAL),
     &          DXNL(NCORD), D0L(NCORD), D0NL(NCORD), DBL(NCORD),
     &          DBNL(NCORD), CZL(NCORD), CZNL(NCORD), CXL(NCORD),
     &          CXNL(NCORD), C0L(NCORD), C0NL(NCORD), CBL(NCORD),
     &          CBNL(NCORD), CONVER(NCORD),BOLTZ(NCORD)
CMR used functions:
      REAL*8 ALFMN,BETAAL,CROSSK,BOLTZK,BETAA,BETAGM,GMMN,RAMINN,
     *       DEPOLN,DELTAZ,DELTAX,DELTA0,DELTAB,CID
      EXTERNAL ALFMN,BETAAL,CROSSK,BOLTZK,BETAA,BETAGM,GMMN,RAMINN,
     *       DEPOLN,DELTAZ,DELTAX,DELTA0,DELTAB,CID
C
C Loop over all freq., calculate properties used in VROA
C
      DO 500 F = 1,NFRVAL
        DO 520 I = 1,NUMMOD
              ALMN  (I) = ALFMN  (ROAAFQ(1,1,F,I))
              BAL   (I) = BETAAL (ROAAFQ(1,1,F,I))
              CONVER(I) = CROSSK (FRVAL(F),FREQ(I))
              BOLTZ (I) = BOLTZK (FREQ(I))
 520    CONTINUE
C
           WRITE(LUPRI,'(/,2X,A,F9.6,A,F9.2,A)')
     &        'Raman Optical Activity properties for freq.  ',
     &         FRVAL(F),' au  =',XTNM/FRVAL(F),' nm'
           WRITE(LUPRI,'(2X,A)')
     &    '---------------------------------------'//
     &    '---------------------------------'
C
        DO 600 I = 1, NUMMOD
          BGML  (I) = BETAGM(ROAAFQ(1,1,F,I),ROAGLQ(1,1,F,I))
          BGMNL (I) = BETAGM(ROAAFQ(1,1,F,I),ROAGNQ(1,1,F,I))
          BA    (I) = BETAA (ROAAFQ(1,1,F,I),ROAAQ(1,1,1,F,I),FRVAL(F))
          GMMNL (I) = GMMN  (ROAGLQ(1,1,F,I))
          GMMNNL(I) = GMMN  (ROAGNQ(1,1,F,I))
          RMINN (I) = RAMINN (ALMN(I),BAL(I))
          DPOLN (I) = DEPOLN (ALMN(I),BAL(I))
          DZL   (I) = DELTAZ(BGML(I),BA(I))
          DZNL  (I) = DELTAZ(BGMNL(I),BA(I))
          DXL   (I) = DELTAX(BGML(I),BA(I),ALMN(I),GMMNL(I))
          DXNL  (I) = DELTAX(BGMNL(I),BA(I),ALMN(I),GMMNNL(I))
          D0L   (I) = DELTA0(BGML(I),BA(I),ALMN(I),GMMNL(I))
          D0NL  (I) = DELTA0(BGMNL(I),BA(I),ALMN(I),GMMNNL(I))
          DBL   (I) = DELTAB(BGML(I),BA(I))
          DBNL  (I) = DELTAB(BGMNL(I),BA(I))
          CZL   (I) = CID(DZL(I),RMINN(I)*DPOLN(I))
          CZNL  (I) = CID(DZNL(I),RMINN(I)*DPOLN(I))
          CXL   (I) = CID(DXL(I),RMINN(I))
          CXNL  (I) = CID(DXNL(I),RMINN(I))
          C0L   (I) = CID(D0L(I),D2*RMINN(I))
          C0NL  (I) = CID(D0NL(I),D2*RMINN(I))
          CBL   (I) = CID(DBL(I),D2*RMINN(I))
          CBNL  (I) = CID(DBNL(I),D2*RMINN(I))
  600   CONTINUE
        WRITE (LUPRI,'(A)') ' '
        WRITE (LUPRI,'(A)') ' note: Depolarization Ratio for '//
     *        'right-angle scattering,'
        WRITE (LUPRI,'(A)') '       natural or circ.pol. '//
     *        'incident light (=par/per):'
        WRITE (LUPRI,'(A)') '       DepRatio = (6*BETA**2)/'//
     *        '(45*ALFMN**2 + 7*BETA**2)'
        WRITE (LUPRI,'(A)') ' '
C
        WRITE (LUPRI,'(/,3X,A)')
     &      '**** Raman invariants and Intensity Parameters'//
     &      ' (A**4amu**-1) ****'
        WRITE (LUPRI,'(/,1X,A,/)')
     &      'Mode  Freq.     Alpha**2   Beta(a)**2'//
     &       '   Pol.Int. DepolInt. 180/0Int.  DepRatio'
        DO 700 I = 1, NUMMOD
            WRITE(LUPRI,'(I4,F10.2,2F12.6,4F10.4)')
     &            I, XTKAYS*FREQ(I),ALMN(I)**2*XFRAIN,BAL(I)*XFRAIN,
     &            RMINN(I)*XFRAIN,DPOLN(I)*RMINN(I)*XFRAIN,
     &            D2*RMINN(I)*XFRAIN,DPOLN(I)
  700   CONTINUE
        WRITE (LUPRI,'(/,3X,A)')
     &      '**** ROA invariants (*E6, in A**4amu**-1) ****'
        WRITE (LUPRI,'(/,1X,A,/)')
     &      'Mode   Freq.     a*Gm(Lon)  a*Gm(noL)'//
     &      '   Beta(Gm)**2 (L/noL)    Beta(A)**2'
        DO 705 I = 1, NUMMOD
          WRITE (LUPRI,'(I4,1X,F8.2,2F12.4,3F12.2)') I, XTKAYS*FREQ(I),
     &           ALMN(I)*GMMNL(I)*XFOAIN,ALMN(I)*GMMNNL(I)*XFOAIN,
     &           BGML(I)*XFOAIN,BGMNL(I)*XFOAIN,BA(I)*XFOAIN
 705    CONTINUE
        WRITE (LUPRI,'(/,3X,A)')
     &      '**** Conversion Factor to Cross Section (*E13)'//
     &      ' and Boltzmann Factor'
        WRITE (LUPRI,'(/,1X,A,/)')
     &      'Mode  Freq.     ConverFac(*E13)   BoltzFac'
        DO 710 I = 1, NUMMOD
            WRITE(LUPRI,'(I4,F10.2,F14.6,F16.8)')
     &              I, XTKAYS*FREQ(I),CONVER(I)*XFCONV,BOLTZ(I)
  710   CONTINUE
C
C Difference Parameter = 4/c * (45aGm+7beta(Gm)+beta(A)  etc.
C
        WRITE (LUPRI,'(/,3X,A,//,2X,A,/)') '**** Difference '//
     &        'Parameter R-L (A**4amu**-1) (London orbitals) ****',
     &        'Mode   Frequency     DELTApar      DELTAperp  '//
     &         '    DELTA0       DELTA180'
        DO 750 I = 1, NUMMOD
          WRITE(LUPRI,'(1X,I4,2X,F10.2,4F14.6)')I,XTKAYS*FREQ(I),
     &     DZL(I)*XFRAIN,DXL(I)*XFRAIN,D0L(I)*XFRAIN,DBL(I)*XFRAIN
  750   CONTINUE
C
C  Here are printed the CIDs (Definition of Barron):
C  CID = (R-L) / (2*Intensity)
C
           WRITE (LUPRI,'(/,3X,A,//,2X,A,/)') '*** Circular '//
     &       'Intensity difference CID=(R-L)/(2*Int) (*E3) '//
     &          '(London) ***','Mode   Frequency      CID(par)'//
     &          '      CID(perp)     CID(0)       CID(180)'
        DO 800 I = 1, NUMMOD
            WRITE(LUPRI,'(1X,I4,2X,F10.2,4F14.6)') I, XTKAYS*FREQ(I),
     &              CZL(I)*DE3,CXL(I)*DE3,
     &              C0L(I)*DE3,CBL(I)*DE3
  800   CONTINUE
C
C Difference NoLondon
C
        WRITE (LUPRI,'(/,3X,A,//,2X,A,/)') '**** Difference '//
     &         'Parameter R-L (A**4amu**-1) (NoLondon) ****',
     &        'Mode   Frequency     DELTApar      DELTAperp   '//
     &         '   DELTA0       DELTA180'
        DO 760 I = 1, NUMMOD
          WRITE(LUPRI,'(1X,I4,2X,F10.2,4F14.6)')I,XTKAYS*FREQ(I),
     &    DZNL(I)*XFRAIN,DXNL(I)*XFRAIN,D0NL(I)*XFRAIN,DBNL(I)*XFRAIN
 760    CONTINUE
C
C  CIDs NoLondon
C
           WRITE (LUPRI,'(/,3X,A,//,2X,A,/)') '*** Circular '// 
     &       'Intensity difference CID=(R-L)/(2*Int) (*E3) '//
     &       ' (NoLon) ***',
     &          'Mode   Frequency      CID(par)    CID(perp)'//
     &          '     CID(0)       CID(180)'
         DO 810 I = 1, NUMMOD
            WRITE(LUPRI,'(1X,I4,2X,F10.2,4F14.6)') I, XTKAYS*FREQ(I),
     &              CZNL(I)*DE3,CXNL(I)*DE3,
     &              C0NL(I)*DE3,CBNL(I)*DE3
  810    CONTINUE
  500 CONTINUE
C
C  End of Raman and VROA output for one frequency,taking next
C
      WRITE (LUPRI,'(/,3X,A/)') '**** For definitions, '//
     &    'see the DALTON manual and references therein. ****'
C
      RETURN
      END
