CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine adfrslave(grad,co,ilab,nmode,freq,intonly,nummodes)
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C written by C. Herrmann, Uni Jena, 05/2005
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      include 'defs.h'
      include 'comm.h'
      include 'param.h'  

      integer ibuf,info,nn,iat,idum,ixyz,irc,idir,l,mypid
      integer idmy,j,mbuf,diraus,ladf,iclean,icleanl
      character*255 adfname
      real*8 escf,gsum
      real*8 nmode(maxmode,maxatoms*3),freq(maxmode)

      integer lprop,lpol,ldscf,lgrad,kstep,xprog,ldmol
      integer xprogb
      integer*4 itst,jstepa
      character*255 b1
      character*5 nic
      character*80 sdum
      character*24 date,dmname
      character*255 dscfname,gradname,propname,polname
      real*8 cpu,wall,gcpu,gwall
      integer nit
      integer xeq,tmpxeq,icmp
      real*8 grad(nvar),dipol(3),co(3,natoms),polar(8,mxomeg)
      real*8 gtenlao(9,mxomeg),gtenao(9,mxomeg),aten(27,mxomeg)
      real*8 dipal(3),dipbe(3)
      integer ilab(natoms)

      logical found,snffast
C#    integer w,st(MPI_STATUS_SIZE)
C#    data w /MPI_COMM_WORLD/
 
      integer intonly,nummodes
      character*255 forceout,adfdipin,adfdipout,adfpolin,adfpolout
      integer lfout,ladfdi,ladfdo,ladfpoli,ladfpolo

      nic='nice '
      kstep=1

*-------------------
* call rslave module
*-------------------
      call rslave(co,ilab,jstepa,nmode,freq,intonly,nummodes)

*------------------------------------------------------------------
* do the calculation
* (at the moment, one optimization cycle is run - should be replaced
* by a pure calculation of forces for higher efficiency) (CH 04/05)
* - this also requires that for the dipole moments an extra single-point
* calculation is run - otherwise, we would get the dipoles for 
* the (displaced) structure after one optimization cycle.
*-------------------------------------------------------------------
      if(snffast) then
        nic='     '
        write (iosl,*) '** found $snffast flag: omitting command nice'
      end if
      call flush(iosl)
      if(snffast) then
        nic='     '
        write (iosl,*) 'test calculation: omitting command nice'
      end if
*-------------------------------------------------------------------
* remove TAPE21 and t21* files from previous ADF runs
* (otherwise, ADF will not run properly)
*-------------------------------------------------------------------
         info=system('rm '//tempdir(1:lt)//'/'//'TAPE21 t21*')
*--------------------------
* prepare in-/output file names
*--------------------------
      call augnum(adfname,'adf.out.',jstepa)
      call llen(adfname,ladf)
      call augnum(adfdipin,'adfdip.in.',jstepa)
      call llen(adfdipin,ladfdi)
      call augnum(adfdipout,'adfdip.out.',jstepa)
      call llen(adfdipout,ladfdo)
*-----------
* run ADF
*-----------
           info=system('chmod u+x '//tempdir(1:lt)//'/adfslave.in')
           info=xprog(nic(1:5)//tempdir(1:lt)//'/adfslave.in',
     *          tempdir(1:lt)//'/'//adfname(1:ladf))

*-------------------------------------------------------------------
* extract gradient information from TAPE21
*-------------------------------------------------------------------
         CALL augnum(forceout,'grad.out.',jstepa)
         CALL llen(forceout,lfout)
        info=xprog(nic(1:5)//'dmpkf '//tempdir(1:lt)//'/TAPE21 GeoOpt',
     *  tempdir(1:lt)//'/'//forceout(1:lfout))
*-------------------------------------
* read gradient 
*-------------------------------------
      CALL gadfgrad(natoms,grad,tempdir(1:lt)//'/'
     *                //forceout(1:lfout))

*-----------------------------------------------------------
* get dipole moments:
* 1) prepare input file for single-point calculation
* 2) perform single-point calculation
* 3) extract components of dipole moment from output
*------------------------------------------------------------
      if(ipol.eq.0) then
      call wadfdip(tempdir(1:lt),adfdipin(1:ladfdi),iosl)
      info=system('rm '//tempdir(1:lt)//'/'//'TAPE21 t21*')
      info=xprog(nic(1:5)//tempdir(1:lt)//'/'//adfdipin(1:ladfdi),
     *          tempdir(1:lt)//'/'//adfdipout(1:ladfdo))
      call gadfdip(dipol,tempdir(1:lt)//'/'//adfdipout(1:ladfdo),iosl)
*------------------------------------------------------------
* get polarizabilities (and dipoles):
* 1) prepare input file for single-point calculation
* 2) perform single-point calculation
* 3) extract components of dipole moment from output
* 4) extract components of polarizability from output
*------------------------------------------------------------
      else
        call augnum(adfpolin,'adfpol.in.',jstepa)
        call llen(adfpolin,ladfpoli)
        call augnum(adfpolout,'adfpol.out.',jstepa)
        call llen(adfpolout,ladfpolo)
        call wadfpol(tempdir(1:lt),adfpolin(1:ladfpoli),iosl)
        info=system('rm '//tempdir(1:lt)//'/'//'TAPE21 t21*')
        info=xprog(nic(1:5)//tempdir(1:lt)//'/'//adfpolin(1:ladfpoli),
     *          tempdir(1:lt)//'/'//adfpolout(1:ladfpolo))
        call gadfpol(dipol,polar,tempdir(1:lt)//'/'
     * //adfpolout(1:ladfpolo),iosl)
      end if
      nit=0
      cpu=0.d0
      gcpu=0.d0
      wall=0.d0
      gwall=0.d0
      call mnotify(5,mypid,6,'times read',10)
CCH      CALL rxxxx('?',nit,cpu,wall)
*---------------------------------------------------
* read and save total bonding energy
*---------------------------------------------------
      CALL gadfenergy(tempdir(1:lt)//'/'//adfname(1:ladf),escf)
      call mnotify(5,mypid,5,'results read',12)

      gsum=0.0d0
      do j=1,nvar    
         gsum=gsum+grad(j)**2
      enddo
      write (iosl,*) 'grad norm',gsum
      call flush(iosl)

      call clean(sdum)

*-------------------
* send final results
*-------------------
C:      call MPI_SSEND(nit,1,MPI_INTEGER,tid0,fsys_restag,w,info)
C:      call mpierr('MPI_SSEND nit','rslave',info)
C:      call MPI_SSEND(cpu,1,MPI_DOUBLE_PRECISION,tid0,801,w,info)
C:      call mpierr('MPI_SSEND cpu','rslave',info)
C:      call MPI_SSEND(wall,1,MPI_DOUBLE_PRECISION,tid0,802,w,info)
C:      call mpierr('MPI_SSEND wall','rslave',info)
C:      call MPI_SSEND(gcpu,1,MPI_DOUBLE_PRECISION,tid0,803,w,info)
C:      call mpierr('MPI_SSEND gcpu','rslave',info)
C:      call MPI_SSEND(gwall,1,MPI_DOUBLE_PRECISION,tid0,804,w,info)
C:      call mpierr('MPI_SSEND gwall','rslave',info)
C:      call MPI_SSEND(escf,1,MPI_DOUBLE_PRECISION,tid0,805,w,info)
C:      call mpierr('MPI_SSEND out1','rslave',info)
C:      call MPI_SSEND(dipol,3,MPI_DOUBLE_PRECISION,tid0,806,w,info)
C:      call mpierr('MPI_SSEND dipol','rslave',info)
C:      call MPI_SSEND(grad,nvar,MPI_DOUBLE_PRECISION,
C:   *   tid0,807,w,info)
C:      call mpierr('MPI_SSEND escf','rslave',info)
C:      IF (ipol.GT.0) THEN
C:       call MPI_SSEND(polar,8*ipol,MPI_DOUBLE_PRECISION,
C:   *    tid0,808,w,info)
C:       call mpierr('MPI_SSEND polar','rslave',info)
C:      end if
C//SKIPC:
C#      call MPI_SEND(nit,1,MPI_INTEGER,tid0,fsys_restag,w,info)
C#      call mpierr('MPI_SEND nit','rslave',info)
C#      call MPI_SEND(cpu,1,MPI_DOUBLE_PRECISION,tid0,801,w,info)
C#      call mpierr('MPI_SEND cpu','rslave',info)
C#      call MPI_SEND(wall,1,MPI_DOUBLE_PRECISION,tid0,802,w,info)
C#      call mpierr('MPI_SEND wall','rslave',info)
C#      call MPI_SEND(gcpu,1,MPI_DOUBLE_PRECISION,tid0,803,w,info)
C#      call mpierr('MPI_SEND gcpu','rslave',info)
C#      call MPI_SEND(gwall,1,MPI_DOUBLE_PRECISION,tid0,804,w,info)
C#      call mpierr('MPI_SEND gwall','rslave',info)
C#      call MPI_SEND(escf,1,MPI_DOUBLE_PRECISION,tid0,805,w,info)
C#      call mpierr('MPI_SEND escf','rslave',info)
C#      call MPI_SEND(dipol,3,MPI_DOUBLE_PRECISION,tid0,806,w,info)
C#      call mpierr('MPI_SEND dipol','rslave',info)
C#      call MPI_SEND(grad,nvar,MPI_DOUBLE_PRECISION,
C#   *   tid0,807,w,info)
C#      call mpierr('MPI_SEND grad','rslave',info)
C#      if (ipol.GT.0) then
C#       call MPI_SEND(polar,8*ipol,MPI_DOUBLE_PRECISION,
C#   *    tid0,808,w,info)
C#       call mpierr('MPI_SEND polar','rslave',info)
C#      end if
C//END
C//SKIPC#
      call PVMFINITSEND(PVMDATADEFAULT,MBUF)
      call PVMFPACK(INTEGER4,nit,kstep,1,info)
      call PVMFPACK(REAL8,cpu,kstep,1,info)
      call PVMFPACK(REAL8,wall,kstep,1,info)
      call PVMFPACK(REAL8,gcpu,kstep,1,info)
      call PVMFPACK(REAL8,gwall,kstep,1,info)
      call PVMFPACK(REAL8,escf,1,1, INFO )
      call PVMFPACK(REAL8,dipol,3,1,INFO )
      call PVMFPACK(REAL8,grad,nvar,1,INFO )
      IF (ipol.GT.0)  
     *  call PVMFPACK(REAL8,polar,8*ipol,1,INFO )
      call PVMFSEND( TID0, 0, INFO )
C//END
      call mnotify(5,mypid,9,'results sent',12)
      return
      end                        
