CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine cslave(nmode,freq,intonly,nummodes)
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C re-written by J. Neugebauer, Uni Erlangen, 2003
CCH modified by C. Herrmann, Uni Bonn, February 2005 (intonly tool)
CCH modified by C. Herrmann, Uni Jena, April 2005 (ADF interface)
CCH modified by C. Herrmann, Uni Jena, May 2005 (Gaussian interface)
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      include 'defs.h'
      include 'param.h'
      include 'objects.h'

      integer pgrad,pc,pl
      real*8 nmode(maxmode,maxatoms*3),freq(maxmode)
      integer intonly,nummodes

      nvar=3*natoms

      call memmgr(memgdw,'grad    ',s8,pgrad ,nvar)
      call memmgr(memgdw,'co      ',s8,pc,natoms*3)
      call memmgr(memget,'ilab    ',is,pl,natoms)
      if(progno.eq.1) then
        call tmrslave(s8(pgrad),s8(pc),is(pl),nmode,freq,intonly,
     *                nummodes)
      else if(progno.eq.2) then
        call daltonrslave(s8(pgrad),s8(pc),is(pl),nmode,freq,intonly,
     *        nummodes)
      else if(progno.eq.3) then
        call g98rslave(s8(pgrad),s8(pc),is(pl),nmode,freq,intonly,
     *        nummodes)
      else if(progno.eq.4) then
        call adfrslave(s8(pgrad),s8(pc),is(pl),nmode,freq,intonly,
     *        nummodes)
      end if
      call memmgr(memfdw,'grad    ',s8,pgrad ,nvar)
      call memmgr(memfdw,'co      ',s8,pc,natoms*3)
      call memmgr(memfre,'ilab    ',is,pl,natoms)
      return
      end
