CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE getgrad(nat,escf,grad,name)
* read SCF energy and gradient from file <name>
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER nat
      INTEGER lu,irc,ist,ien,i,k
      CHARACTER*(*) name
      REAL*8 escf,grad(*),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      escf=0.D0
      DO i=1,3*nat
       grad(i)=0.D0
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'cycle') GOTO 91
      GOTO 90
91    CONTINUE
      ist=1
      if(index(item(4),'ex').ne.0) then
        escf=getreal(item(8),ist,ien)
      else
        escf=getreal(item(7),ist,ien)
      end if
      DO i=1,nat
       READ (lu,'(A)',END=99) rec
      ENDDO
      k=0
      DO i=1,nat
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       k=k+1
       grad(k)=getreal(item(1),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(2),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(3),ist,ien)
      ENDDO
      GOTO 90

99    CONTINUE
      CALL prmat(iosl,escf,1,1,'getgrad: SCF energy')
      CALL prmat(iosl,grad,nat,3,'getgrad: gradient')
      CALL flush(iosl)
      RETURN
      END

      SUBROUTINE gdalgrad(nat,escf,grad,name)
*
* read CCS/CCSD/CC2 energy and gradient from file <name>
* in case of DALTON Coupled Cluster (or MP2) calculations
* 
* written by J. Neugebauer, Uni Erlangen, 2002.
* 
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER nat
      INTEGER lu,irc,ist,ien,i,k
      CHARACTER*(*) name
      REAL*8 escf,grad(*),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      escf=0.D0
      DO i=1,3*nat
       grad(i)=0.D0
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF(calcno.eq.4.and.(index(rec,'Final    HF energy:').ne.0)) 
     & goto 91
      IF (item(1).EQ.'Total'.and.item(3).eq.'energy:'.and.
     & (item(2).eq.'CC2'.or.item(2).eq.'CCSD'.or.
     & (item(2).eq.'MP2'.and.(calcno.eq.2.or.calcno.eq.8)))) GOTO 91
      GOTO 90
91    CONTINUE
      ist=1
      escf=getreal(item(4),ist,ien)
92    READ (lu,'(A)',END=99) rec
      IF(index(rec,'Molecular gradient').ne.0) GOTO 93
      GOTO 92
93    CONTINUE
      READ (lu,'(A)',END=99) rec
      READ (lu,'(A)',END=99) rec
      k=0
      DO i=1,nat
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       k=k+1
       grad(k)=getreal(item(2),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(3),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(4),ist,ien)
      ENDDO
      GOTO 90

99    CONTINUE
      CLOSE(lu)
      CALL prmat(iosl,escf,1,1,'getgrad: Total energy')
      CALL prmat(iosl,grad,nat,3,'getgrad: gradient')
      CALL flush(iosl)
      RETURN
      END
 
      SUBROUTINE gdalgradscf(nat,escf,grad,name)
*
* read SCF energy and gradient from file <name>
* in case of DALTON SCF/MCSCF calculations
* 
* written by J. Neugebauer, Uni Erlangen, 2002.
* changed by M. Reiher, Uni Bonn, April 2004.
* 
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER nat
      INTEGER lu,irc,ist,ien,i,k
      CHARACTER*(*) name
      REAL*8 escf,grad(*),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      escf=0.D0
      DO i=1,3*nat
       grad(i)=0.D0
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      IF(calcno.eq.6) then
        IF (index(rec,'Final MCSCF energy:').ne.0) then
          read(rec(25:),*) escf
          goto 91
        END IF
      ELSE
CMR30404
CMR30404 The following command was correct for old versions
CMR30404   of DALTON. It does now no longer work because of
CMR30404   inclusion of DFT in DALTON, which led to changes in
CMR30404   in DALTON output.
CMR30404 By the way, the new string to be looked for is:
CMR30404   "Final HF energy:"
CMR30404   (but this will be different for DFT, which is not 
CMR30404    checked separately in daltonrslave.r)
CMR30404 Now, the energy is taken from the property section, which
CMR30404  will hopefully do not cause any problems for other program modes.
CMR30404
CMR30404        IF (index(rec,'Final    HF energy:').ne.0) then
CMR30404          read(rec(25:),*) escf
        IF (index(rec(4:19),'Total energy').ne.0) then
          read(rec(25:40),*) escf
          goto 91
        END IF
CMR30404
      END IF
      GOTO 90
91    CONTINUE
      ist=1
92    READ (lu,'(A)',END=99) rec
      IF(index(rec,'Molecular gradient').ne.0) GOTO 93
      GOTO 92
93    CONTINUE
      READ (lu,'(A)',END=99) rec
      READ (lu,'(A)',END=99) rec
      k=0
      DO i=1,nat
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       k=k+1
       grad(k)=getreal(item(2),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(3),ist,ien)
       ist=1
       k=k+1
       grad(k)=getreal(item(4),ist,ien)
      ENDDO
      GOTO 90

99    CONTINUE
      CLOSE(lu)
      CALL prmat(iosl,escf,1,1,'getgrad: Total energy')
      CALL prmat(iosl,grad,nat,3,'getgrad: gradient')
      CALL flush(iosl)
      RETURN
      END

************************************************************************

      subroutine gadfgrad(nat,grad,name)
c
c written by C. Herrmann, Uni Jena 2005
c
* read gradient from file <name> in ADF format
* ADF does not provide total energies.
c
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER nat,mypid
      INTEGER lu,irc,ist,ien,i,k
      CHARACTER*(*) name
      REAL*8 grad(*),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      logical normterm
CCH      normterm = .false.
      DO i=1,3*nat
       grad(i)=0.D0
      ENDDO
      lu=11
      write(iosl,*) 'gadfgrad: reading gradient from file '//name(1:100)
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'Gradients') GOTO 91
*-------------------------------------------------------------------
* problems during calculation ?
*-------------------------------------------------------------------
CCH cannot be extracted from TAPE21... (?) to be checked!
*-------------------------------------------------------------------
      GOTO 90
91    CONTINUE
      READ (lu,'(A)',END=99) rec
       k=0
       DO i=1,nat
         READ (lu,'(A)',END=99) rec
         CALL split(rec,item,mxitem)
         ist=1
         k=k+1
         grad(k)=getreal(item(1),ist,ien)
         ist=1
         k=k+1
         grad(k)=getreal(item(2),ist,ien)
         ist=1
         k=k+1
         grad(k)=getreal(item(3),ist,ien)
       ENDDO
       GOTO 90

99    CONTINUE
CCH  Normal termination check not implemented yet for ADF
CCH      if(.not.normterm) then
CCH        write(iosl,*) 'rslavem40: problem found in
CCH     1  calculation of gradients - snfdc will continue anyway'
CCH       CALL mnotify(5,mypid,7,'problem occured',13)
CCHC*       WRITE (iosl,*)
CCHC*     * 'found problem ... shutting down node'
CCHC*       CALL flush(iosl)
CCHC*       CALL slshutdown(1,tid0,mytid)
CCH      ENDIF

      write(iosl,*) (grad(i),i = 1,3*nat)
      CALL prmat(iosl,grad,nat,3,'gadfgrad: gradient')
      CALL flush(iosl)
      CLOSE(lu)
      RETURN
      END subroutine

************************************************************************

      subroutine gadfenergy(name,escf)
c
c written by C. Herrmann, Uni Jena 2005
c
c reads bonding energy from ADF output file name
c
      include 'defs.h'
      character*(*) name
      real*8 escf,getreal
      integer lu,mxitem,ist,ien
      parameter(mxitem = 10)
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
c
      lu = 12
      escf = 0.d0
      write(iosl,*) ' * gadfenergy: trying to read energy from ',name
      call flush(iosl)
      open(unit=lu,file=name,STATUS='UNKNOWN')
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'Total'.and.item(2).eq.'Bonding') then
        read(rec(30:128),*) escf
!        escf = getreal(item(4),ist,ien)
        goto 99
      end if
      GOTO 90
99    CONTINUE
      close(lu)
      write(iosl,*) ' * gadfenergy: escf = ',escf
      call flush(iosl)
      RETURN
      END subroutine

c*************************************************************
      subroutine ggaussgrad(nat,escf,dip,grad,name)
c
c written by C. Herrmann, Uni Jena 2005
c
c read gradients, dipoles and total energy from Gaussian
c output file 'name' 
c
      include 'defs.h'
      real*8 au2deb
c conversion factor from [a.u.] to [Debye]:
      parameter(au2deb=2.541765)
      character*(*) name
      real*8 grad(*),dip(*),escf,getreal
      integer lu,mxitem,ist,ien,i,nat,k,mypid
      parameter(mxitem = 10)
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      logical normterm
c      
      normterm=.false.
      DO i=1,3*nat
       grad(i)=0.D0
      ENDDO
      do i = 1,3
        dip(i)=0
      end do
      lu = 12
      escf = 0.d0
      write(iosl,*) ' * ggaussgrad: trying to read gradients, dipoles '
      write(iosl,*),'               and energies from file ',name
      call flush(iosl)
      open(unit=lu,file=name,STATUS='UNKNOWN')
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'Center'.and.item(3).eq.'Forces') GOTO 91 
      IF (item(1).EQ.'SCF'.and.item(2).eq.'Done:') GOTO 92
      IF(item(1).eq.'Dipole'.and.item(2).eq.'moment') goto 93
*------------------------------------------------------------------- 
* problems during calculation ?
*-------------------------------------------------------------------       
      IF (item(1).eq.'Normal'.and.item(2).eq.'termination')
     1  normterm = .true.                                        
*----------------------------------
      GOTO 90
c----------------------------------------
91    CONTINUE
      READ (lu,'(A)',END=99) rec 
      READ (lu,'(A)',END=99) rec
       k=0                                             
       DO i=1,nat
         READ (lu,'(A)',END=99) rec   
         CALL split(rec,item,mxitem)
         ist=1                                                   
         k=k+1
         grad(k)=getreal(item(3),ist,ien)*(-1)   
         ist=1
         k=k+1
         grad(k)=getreal(item(4),ist,ien)*(-1)
         ist=1
         k=k+1
         grad(k)=getreal(item(5),ist,ien)*(-1)
       ENDDO
       GOTO 90
c----------------------------------------
92     CONTINUE
       ist=1
       escf=getreal(item(5),ist,ien)
       GOTO 90
c----------------------------------------
93     CONTINUE
       READ (lu,'(A)',END=99) rec 
       CALL split(rec,item,mxitem)
       ist=1
       dip(1)=(1/au2deb)*getreal(item(2),ist,ien)
       dip(2)=(1/au2deb)*getreal(item(4),ist,ien)
       dip(3)=(1/au2deb)*getreal(item(6),ist,ien)
       goto 90
c----------------------------------------
99    CONTINUE
      if(.not.normterm) then
        write(iosl,*) 'g98rslave: problem found in
     1  calculation of gradients - snfdc will continue anyway'
       CALL mnotify(5,mypid,7,'problem occured',13)
C*       WRITE (iosl,*)
C*     * 'found problem ... shutting down node'
C*       CALL flush(iosl)
C*       CALL slshutdown(1,tid0,mytid)
      ENDIF
      CALL prmat(iosl,escf,1,1,'getgrad: SCF energy')
      CALL prmat(iosl,grad,nat,3,'getgrad: gradient')
      CALL prmat(iosl,dip,1,3,'getgrad: dipole moment')
      CALL flush(iosl)
      close(lu)
      RETURN
      end subroutine
