CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE getpol(pol,name)
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
* read polarizabilities from file <name>
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i,jomeg,iind,isvers
      CHARACTER*(*) name
      REAL*8 pol(8,mxomeg),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,8
       DO jomeg=1,ipol
         pol(i,jomeg)=0.0d0
       ENDDO
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
      jomeg=0
20    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      if(item(3).eq.'TURBOMOLE') then
        iind=index(item(4),'V5-')
        if(iind.ne.0) then
          read(item(4)(iind+3:iind+3),'(i1)') isvers
          write(iosl,'(1x,a,i1)') 'found escf Version V5-',isvers
          if(isvers.lt.6) then
            goto 90
          else
            goto 70
          end if
        else if(item(4).EQ.'working') then
          write(iosl,*) 'found working version'
          goto 70
        else
          call errex('getpol not prepared for this escf Version')
        end if
      end if
      GOTO 20
70    READ (lu,'(A)',END=99) rec
      IF(index(rec,'Electronic dipole').eq.0) GOTO 70
      READ (lu,'(A)',END=99) rec
      READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'xx') THEN
       jomeg=jomeg+1
       ist=1
       pol(1,jomeg)=getreal(item(2),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(4,jomeg)=getreal(item(2),ist,ien)
       ist=1
       pol(7,jomeg)=getreal(item(4),ist,ien)
       ist=1
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       pol(6,jomeg)=getreal(item(2),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(2,jomeg)=getreal(item(2),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(3,jomeg)=getreal(item(2),ist,ien)
       ist=1
       pol(8,jomeg)=getreal(item(4),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(5,jomeg)=getreal(item(2),ist,ien)
       CALL prmat(iosl,pol(1,jomeg),1,8,'getpol: polarizability')
      ENDIF
      GOTO 70
90    READ (lu,'(A)',END=99) rec
      CALL split(rec,item,mxitem)
      IF (item(1).EQ.'XX' .AND. item(2).EQ.'=') THEN
       jomeg=jomeg+1
       ist=1
       pol(1,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(2,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(3,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(4,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(5,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(6,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(7,jomeg)=getreal(item(3),ist,ien)
       READ (lu,'(A)',END=99) rec
       CALL split(rec,item,mxitem)
       ist=1
       pol(8,jomeg)=getreal(item(3),ist,ien)
       CALL prmat(iosl,pol(1,jomeg),1,8,'getpol: polarizability')
      ENDIF
      GOTO 90
99    CONTINUE
      IF (jomeg.NE.ipol) THEN
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       WRITE (iosl,*) ' getpol| error while reading pols. from ',name
       WRITE (iosl,*) '       | No. of pol. sets expected: ',ipol
       WRITE (iosl,*) '       | No. of pol. sets found:    ',jomeg
       WRITE (iosl,*) '       | Check $TMPDIR/pol.out.(XX) for details'
       WRITE (iosl,*) '       | (maybe escf did not converge)'
       CALL errex('jomeg=/=ipol in getpol')
      ENDIF
      CALL prmat(iosl,pol,ipol,8,'getpol: polarizability')
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      CALL flush(iosl)
      RETURN
      END

      SUBROUTINE gdalpol(pol,name)
* read polarizabilities from file <name>
* in case of DALTON Coupled Cluster calculations
* written by J. Neugebauer, Uni Erlangen, 2002
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i,jomeg,j,jj
      CHARACTER*(*) name
      REAL*8 pol(8,mxomeg),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,8
       DO jomeg=1,ipol
        pol(i,jomeg)=0.0d0
       ENDDO
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
      jomeg=0
70    READ (lu,'(A)',END=99) rec
      IF(index(rec,'A operator                  B oper').eq.0) GOTO 70
      READ (lu,'(A)',END=99) rec
      READ (lu,'(A)',END=99) rec
      do j=1,9
       if(j.eq.4.or.j.eq.7.or.j.eq.8) then
        do i=1,ipol+1
         READ (lu,'(A)',END=99) rec
        end do
        goto 80
       end if
       do i=1,ipol
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        ist=1
        jj=j
        if(j.eq.5.or.j.eq.6) jj=jj-1
        if(j.eq.9) jj=6
        if(i.gt.1) then
         pol(jj,i)=getreal(item(3),ist,ien)
        else
         pol(jj,i)=getreal(item(7),ist,ien)
        end if
       end do
       read (lu,'(A)',END=99) rec
80    continue
      end do
99    continue
      close(lu)
      jomeg=i-1
      if (jomeg.ne.ipol) then
       write (iosl,*) ' getpol| error while reading pols. from ',name
       write (iosl,*) '       | No. of pol. sets expected: ',ipol
       write (iosl,*) '       | No. of pol. sets found:    ',jomeg
       write (iosl,*) '       | Check $TMPDIR/pol.out.(XX) for details'
       write (iosl,*) '       | (maybe escf did not converge)'
       call errex('jomeg=/=ipol in getpol')
      end if
      CALL prmat(iosl,pol,ipol,8,'getpol: polarizability')
      CALL flush(iosl)
      RETURN
      END

      SUBROUTINE gdalpolscf(pol,name)
*-----------------------------------------------
* read polarizabilities from file <name>
* in case of DALTON SCF/MCSCF calculations
* written by J. Neugebauer, Uni Erlangen, 2002
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
* re-written by J. Neugebauer, Uni Erlangen, 2003
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*-----------------------------------------------
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i,jomeg,j,jj
      CHARACTER*(*) name
      REAL*8 pol(8,mxomeg),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,8
       DO jomeg=1,ipol
        pol(i,jomeg)=0.0d0
       ENDDO
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
      jomeg=0
      if(ipol.gt.1) then
*-------------------------
* dynamic polarizabilities
*-------------------------
        goto 90
      else
*-----------------------------------
* static OR dynamic polarizabilities
*-----------------------------------
        goto 70
      end if

*------------------------------------
* try to find static polarizabilities
*------------------------------------
70    READ (lu,'(A)',END=89) rec
      IF(index(rec,'Static polarizabilities (au)').eq.0) GOTO 70
      do j=1,5
        READ (lu,'(A)',END=89) rec
      end do
      READ (lu,'(A)',END=89) rec
      CALL split(rec,item,mxitem)
      ist=1
      pol(1,1)=getreal(item(2),ist,ien)
      ist=1
      pol(2,1)=getreal(item(3),ist,ien)
      ist=1
      pol(3,1)=getreal(item(4),ist,ien)
      READ (lu,'(A)',END=89) rec
      CALL split(rec,item,mxitem)
      ist=1
      pol(4,1)=getreal(item(3),ist,ien)
      ist=1
      pol(5,1)=getreal(item(4),ist,ien)
      READ (lu,'(A)',END=89) rec
      CALL split(rec,item,mxitem)
      ist=1
      pol(6,1)=getreal(item(4),ist,ien)
80    READ (lu,'(A)',END=89) rec
      IF(index(rec,'Mean value:').eq.0) GOTO 80
      CALL split(rec,item,mxitem)
      ist=1
      pol(7,1)=getreal(item(3),ist,ien)
      ist=1
      pol(8,1)=getreal(item(5),ist,ien)
      jomeg=1

*--------------------------------
* found static polarizabilities ?
*--------------------------------
89    if(jomeg.ne.1) then
         rewind(lu)
      else
         goto 99
      end if

*-------------------------------------
* try to find dynamic polarizabilities
*-------------------------------------
90    do i=1,ipol
91      READ (lu,'(A)',END=99) rec
        IF(index(rec,'Polarizability tensor for freq').eq.0) GOTO 91
        do j=1,4
          READ (lu,'(A)',END=99) rec
        end do
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        ist=1
        pol(1,i)=getreal(item(2),ist,ien)
        ist=1
        pol(2,i)=getreal(item(3),ist,ien)
        ist=1
        pol(3,i)=getreal(item(4),ist,ien)
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        ist=1
        pol(4,i)=getreal(item(3),ist,ien)
        ist=1
        pol(5,i)=getreal(item(4),ist,ien)
        READ (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        ist=1
        pol(6,i)=getreal(item(4),ist,ien)
      end do
99    continue
      close(lu)
      if (jomeg.ne.ipol) then
       write (iosl,*) ' getpol| error while reading pols. from ',name
       write (iosl,*) '       | No. of pol. sets expected: ',ipol
       write (iosl,*) '       | No. of pol. sets found:    ',jomeg
       write (iosl,*) '       | Check $TMPDIR/pol.out.(XX) for details'
       write (iosl,*) '       | (maybe escf did not converge)'
       call errex('jomeg=/=ipol in getpol')
      end if
      call prmat(iosl,pol,ipol,8,'gdalpolscf: polarizability')
      call flush(iosl)
      return
      end



      SUBROUTINE gdalpoltdhf(pol,name)
* read polarizabilities from file <name>
* in case of DALTON TDHF calculations
* written by J. Neugebauer, Uni Erlangen, 2002
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i,jomeg,j,jj
      CHARACTER*(*) name
      REAL*8 pol(8,mxomeg),getreal
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      DO i=1,8
       DO jomeg=1,ipol
        pol(i,jomeg)=0.0d0
       ENDDO
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
      jomeg=0
70    READ (lu,'(A)',END=99) rec
      IF(index(rec,'@XDIPLEN').eq.0) GOTO 70
      jomeg=jomeg+1
      if(jomeg.gt.ipol) call errex('jomeg > ipol in getpoltdhf')
      do j=1,6
        CALL split(rec,item,mxitem)
        ist=1
        pol(j,jomeg)=getreal(item(3),ist,ien)
        read (lu,'(A)',END=99) rec
      end do
      goto 70
99    continue
      CLOSE(lu)
      IF (jomeg.NE.ipol) THEN
       WRITE (iosl,*) ' getpoltdhf| reading from ',name
       WRITE (iosl,*) '           | ipol, jomeg =',ipol,jomeg
       CALL errex('jomeg=/=ipol in getpoltdhf')
      ENDIF
      CALL prmat(iosl,pol,ipol,8,'getpoltdhf: polarizability')
      CALL flush(iosl)
      RETURN
      END

c**************************************************************
c
      subroutine gadfpol(dip,pol,name,iosl)
c
c written by C. Herrmann, Uni Jena 06/05
c
      implicit none
c
      INCLUDE 'param.h'
      include 'fconstants.h'
      INTEGER lu,irc,ist,ien,i,iosl,jomeg
      real*8 pol(8,mxomeg),dip(3),polten(3,3),getreal
      CHARACTER*(*) name
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      character*1 dir(3)
      integer ix,iy,iz
      do i = 1,3
         dip(i)=0.0d0
      end do
      DO i=1,8
        do jomeg=1,ipol
          pol(i,jomeg)=0.0d0
        end do
      ENDDO
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
90    READ (lu,'(A)',END=99) rec
      IF (index(rec,'M U L T I').ne.0) THEN
91      READ (lu,'(A)',END=99) rec
          IF (index(rec,'Dipole Moment').ne.0) THEN
            READ (lu,'(A)',END=99) rec
            READ (lu,'(A)',END=99) rec
            READ (lu,'(A)',END=99) rec
            CALL split(rec,item,mxitem)
            ist=1
            dip(1)=(1/au2deb)*getreal(item(3),ist,ien)
            CALL split(rec,item,mxitem)
             dip(2)=(1/au2deb)*getreal(item(4),ist,ien)
            CALL split(rec,item,mxitem)
            dip(3)=(1/au2deb)*getreal(item(5),ist,ien)
            goto 90
          end if
        goto 91
      ENDIF
      if(index(rec,' POLARIZABILITY CALCULATION').ne.0) then
        jomeg=1
92      READ (lu,'(A)',END=99) rec
        IF (index(rec,'FREQUENCY').ne.0) THEN            
          READ (lu,'(A)',END=99) rec 
          read(rec,*) (dir(i),i=1,3)
          do i = 1,3
            if(dir(i).eq.'X') ix=i
            if(dir(i).eq.'Y') iy=i
            if(dir(i).eq.'Z') iz=i
          end do
          READ (lu,'(A)',END=99) rec 
          read(rec,*) (polten(1,i),i=1,3)
          READ (lu,'(A)',END=99) rec 
          read(rec,*) (polten(2,i),i=1,3)
          READ (lu,'(A)',END=99) rec 
          read(rec,*) (polten(3,i),i=1,3)
          pol(1,jomeg)=polten(ix,ix)
          pol(2,jomeg)=polten(ix,iy)
          pol(3,jomeg)=polten(ix,iz)
          pol(4,jomeg)=polten(iy,iy)
          pol(5,jomeg)=polten(iy,iz)
          pol(6,jomeg)=polten(iz,iz)
          jomeg=jomeg+1
        end if
        goto 92
      end if
      GOTO 90
99    CONTINUE
      CLOSE (UNIT=lu)
      CALL prmat(iosl,dip,1,3,'getpol: dipole')
      CALL flush(iosl)
      RETURN
      end subroutine

c***************************************************************
      subroutine ggausspol(pol,name,iosl)
c
c written by C. Herrmann, Uni Jena 06/05
c
      implicit none
c
      INCLUDE 'param.h'
      include 'fconstants.h'
      INTEGER lu,irc,ist,ien,i,iosl,jomeg
      real*8 pol(8,mxomeg),dip(3),polten(3,3),getreal
      CHARACTER*(*) name
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      character*1 dir(3)
      integer ix,iy,iz
      logical static
      do i = 1,3
         dip(i)=0.0d0
      end do
      DO i=1,8
        do jomeg=1,ipol
          pol(i,jomeg)=0.0d0
        end do
      ENDDO
      jomeg=1
      lu=1
      static=.false.
      if(ipol.eq.1.and.omeg(1).eq.0.0d0) static=.true.
      write(iosl,*) 'STATIC = ',static
      call flush(iosl)
c
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN')
90      READ (lu,'(A)',END=99) rec
        write(iosl,*) 'REC = ',rec
        call flush(iosl)
          IF (.not.static.and.index(rec,'SCF Polarizability').ne.0) THEN
            write(iosl,*) 'NOT STATIC POL FOUND'
            call flush(iosl)
            READ (lu,'(A)',END=99) rec
            READ (lu,'(A)',END=99) rec
            call split(rec,item,mxitem)
            ist=1
            pol(1,jomeg)=getreal(item(2),ist,ien)
            READ (lu,'(A)',END=99) rec
            call split(rec,item,mxitem)
            pol(2,jomeg)=getreal(item(2),ist,ien)
            pol(4,jomeg)=getreal(item(3),ist,ien)
            READ (lu,'(A)',END=99) rec
            call split(rec,item,mxitem)
            pol(3,jomeg)=getreal(item(2),ist,ien)
            pol(5,jomeg)=getreal(item(3),ist,ien)
            pol(6,jomeg)=getreal(item(4),ist,ien)
            jomeg=jomeg+1
            goto 90
        ENDIF
        IF(static.and.index(rec,'Exact polarizability').ne.0) THEN
            write(iosl,*) 'Polar found'
            call flush(iosl)
            call split(rec,item,mxitem)
            ist=1
            pol(1,jomeg)=getreal(item(3),ist,ien)
            pol(2,jomeg)=getreal(item(4),ist,ien)
            pol(4,jomeg)=getreal(item(5),ist,ien)
            pol(3,jomeg)=getreal(item(6),ist,ien)
            pol(5,jomeg)=getreal(item(7),ist,ien)
            pol(6,jomeg)=getreal(item(8),ist,ien)
            write(iosl,*) 'JOMEG = ',jomeg
            write(iosl,*) (pol(i,1),i=1,6)
            call flush(iosl)
            goto 90
        ENDIF
      GOTO 90
99    CONTINUE
      CLOSE (UNIT=lu)
      RETURN
      end subroutine


