CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************

      SUBROUTINE gdalvroascf(pol,gtenlao,gtenao,aten,name)
*-----------------------------------------------
* read polarizabilities, G/LAO, G/AO and A tensors from file <name>
* in case of DALTON SCF, MCSCF, and DFT calculations
* written by M. Reiher, Uni Erlangen, June 2003
*-----------------------------------------------
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER lu,irc,ist,ien,i,jomeg,j,jj,ipoldum,irow,INTGR
      CHARACTER*(*) name
      REAL*8 pol(8,mxomeg),getreal
      REAL*8 gtenlao(9,mxomeg),gtenao(9,mxomeg),aten(27,mxomeg)
      CHARACTER*128 rec
      CHARACTER*128 item(mxitem)
      LOGICAL readerror
c
      EXTERNAL INTGR
c
      readerror=.false.
      irow=0
c
c     NB: static and dynamic property evaluation is not distinguished! :
      if ((ipol-1000).eq.0) ipoldum=1
      if ((ipol-1000).ge.1) ipoldum=ipol-1000
c
c     set entries of arrays equal to zero
c
      DO i=1,8
       DO jomeg=1,ipoldum
        pol(i,jomeg)=0.0d0
       ENDDO
      ENDDO
      DO i=1,9
       DO jomeg=1,ipoldum
        gtenlao(i,jomeg)=0.0d0
        gtenao(i,jomeg)=0.0d0
       ENDDO
      ENDDO
      DO i=1,27
       DO jomeg=1,ipoldum
        aten(i,jomeg)=0.0d0
       ENDDO
      ENDDO
c
      lu=1
      OPEN (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      IF (irc.NE.0) RETURN
      jomeg=0
*-------------------------------------
* try to find polarizabilities
*-------------------------------------
91    READ (lu,'(A)',END=89) rec
      IF(index(rec,'Polarizability tensor at refer').eq.0) GOTO 91
CMR Note: for polarizabilities it is expected that at least
CMR       one component per row does not vanish so that dalton
CMR       always(!) gives 3 lines output for polarizabilities
      do i=1,ipoldum
9143    READ (lu,'(A)',END=89) rec
        IF(index(rec,'frequency:').eq.0) GOTO 9143
9153    READ (lu,'(A)',END=89) rec
        if (index(rec,'Column').eq.0) goto 9153
        READ (lu,'(A)',END=89) rec
        CALL split(rec,item,mxitem)
        ist=1
        pol(1,i)=getreal(item(2),ist,ien)
        ist=1
        pol(2,i)=getreal(item(3),ist,ien)
        ist=1
        pol(3,i)=getreal(item(4),ist,ien)
        READ (lu,'(A)',END=89) rec
        CALL split(rec,item,mxitem)
        ist=1
        pol(4,i)=getreal(item(3),ist,ien)
        ist=1
        pol(5,i)=getreal(item(4),ist,ien)
        READ (lu,'(A)',END=89) rec
        CALL split(rec,item,mxitem)
        ist=1
        pol(6,i)=getreal(item(4),ist,ien)
        jomeg=jomeg+1
      end do
89    if(jomeg.ge.1) then
         rewind(lu)
         jomeg=0
      else
         readerror=.true.
         goto 99
      end if
*-------------------------------------
* try to find G/AO tensor
*-------------------------------------
912   READ (lu,'(A)',END=892) rec
      IF(index(rec,'Non-London G tensor at refer').eq.0) GOTO 912
      do i=1,ipoldum
9142    READ (lu,'(A)',END=892) rec
        IF(index(rec,'frequency:').eq.0) GOTO 9142
9152    READ (lu,'(A)',END=892) rec
        if (index(rec,'Column').eq.0) goto 9152
9112    READ (lu,'(A)',END=892) rec
        CALL split(rec,item,mxitem)
        ist=1
        irow=INTGR(item(1),ist,ien)
        if (irow.eq.1) then
          ist=1
          gtenao(1,i)=getreal(item(2),ist,ien)
          ist=1
          gtenao(2,i)=getreal(item(3),ist,ien)
          ist=1
          gtenao(3,i)=getreal(item(4),ist,ien)
          goto 9112
        else if (irow.eq.2) then
          ist=1
          gtenao(4,i)=getreal(item(2),ist,ien)
          ist=1
          gtenao(5,i)=getreal(item(3),ist,ien)
          ist=1
          gtenao(6,i)=getreal(item(4),ist,ien)
          goto 9112
        else if (irow.eq.3) then
          ist=1
          gtenao(7,i)=getreal(item(2),ist,ien)
          ist=1
          gtenao(8,i)=getreal(item(3),ist,ien)
          ist=1
          gtenao(9,i)=getreal(item(4),ist,ien)
        end if
        jomeg=jomeg+1
      end do
892   if(jomeg.ge.1) then
         rewind(lu)
         jomeg=0
      else
         readerror=.true.
         goto 99
      end if
*-------------------------------------
* try to find G/LAO tensor
*-------------------------------------
911   READ (lu,'(A)',END=891) rec
CMR ... the blank in front of London is essential in the following line:
      IF(index(rec,' London G tensor at refer').eq.0) GOTO 911
      do i=1,ipoldum
9141    READ (lu,'(A)',END=891) rec
        IF(index(rec,'frequency:').eq.0) GOTO 9141
9151    READ (lu,'(A)',END=891) rec
        if (index(rec,'Column').eq.0) goto 9151
9111    READ (lu,'(A)',END=891) rec
        CALL split(rec,item,mxitem)
        ist=1
        irow=INTGR(item(1),ist,ien)
        if (irow.eq.1) then
          ist=1
          gtenlao(1,i)=getreal(item(2),ist,ien)
          ist=1
          gtenlao(2,i)=getreal(item(3),ist,ien)
          ist=1
          gtenlao(3,i)=getreal(item(4),ist,ien)
          goto 9111
        else if (irow.eq.2) then
          ist=1
          gtenlao(4,i)=getreal(item(2),ist,ien)
          ist=1
          gtenlao(5,i)=getreal(item(3),ist,ien)
          ist=1
          gtenlao(6,i)=getreal(item(4),ist,ien)
          goto 9111
        else if (irow.eq.3) then
          ist=1
          gtenlao(7,i)=getreal(item(2),ist,ien)
          ist=1
          gtenlao(8,i)=getreal(item(3),ist,ien)
          ist=1
          gtenlao(9,i)=getreal(item(4),ist,ien)
        end if
        jomeg=jomeg+1
      end do
891   if(jomeg.ge.1) then
         rewind(lu)
         jomeg=0
      else
         readerror=.true.
         goto 99
      end if
*-------------------------------------
* try to find A tensor
*-------------------------------------
913   READ (lu,'(A)',END=893) rec
      IF(index(rec,'A tensor at reference').eq.0) GOTO 913
      do i=1,ipoldum
914     READ (lu,'(A)',END=893) rec
        IF(index(rec,'frequency:').eq.0) GOTO 914
915     READ (lu,'(A)',END=893) rec
        if (index(rec,'Column').eq.0) goto 915
        if (index(rec,'Column   1').ne.0) then
9113      READ (lu,'(A)',END=893) rec
          CALL split(rec,item,mxitem)
          ist=1
          irow=INTGR(item(1),ist,ien)
          if (irow.eq.1) then
            ist=1
            aten(1,i)=getreal(item(2),ist,ien)
            ist=1
            aten(2,i)=getreal(item(3),ist,ien)
            ist=1
            aten(3,i)=getreal(item(4),ist,ien)
            ist=1
            aten(4,i)=getreal(item(5),ist,ien)
            goto 9113
          else if (irow.eq.2) then
            ist=1
            aten(5,i)=getreal(item(2),ist,ien)
            ist=1
            aten(6,i)=getreal(item(3),ist,ien)
            ist=1
            aten(7,i)=getreal(item(4),ist,ien)
            ist=1
            aten(8,i)=getreal(item(5),ist,ien)
            goto 9113
          else if (irow.eq.3) then
            ist=1
            aten(9,i)=getreal(item(2),ist,ien)
            ist=1
            aten(10,i)=getreal(item(3),ist,ien)
            ist=1
            aten(11,i)=getreal(item(4),ist,ien)
            ist=1
            aten(12,i)=getreal(item(5),ist,ien)
          end if
          goto 915
        else if (index(rec,'Column   5').ne.0) then
9114      READ (lu,'(A)',END=893) rec
          CALL split(rec,item,mxitem)
          ist=1
          irow=INTGR(item(1),ist,ien)
          if (irow.eq.1) then
            ist=1
            aten(13,i)=getreal(item(2),ist,ien)
            ist=1
            aten(14,i)=getreal(item(3),ist,ien)
            ist=1
            aten(15,i)=getreal(item(4),ist,ien)
            ist=1
            aten(16,i)=getreal(item(5),ist,ien)
            goto 9114
          else if (irow.eq.2) then
            ist=1
            aten(17,i)=getreal(item(2),ist,ien)
            ist=1
            aten(18,i)=getreal(item(3),ist,ien)
            ist=1
            aten(19,i)=getreal(item(4),ist,ien)
            ist=1
            aten(20,i)=getreal(item(5),ist,ien)
            goto 9114
          else if (irow.eq.3) then
            ist=1
            aten(21,i)=getreal(item(2),ist,ien)
            ist=1
            aten(22,i)=getreal(item(3),ist,ien)
            ist=1
            aten(23,i)=getreal(item(4),ist,ien)
            ist=1
            aten(24,i)=getreal(item(5),ist,ien)
          goto 915
          end if
        else if (index(rec,'Column   9').ne.0) then
9115      READ (lu,'(A)',END=893) rec
          CALL split(rec,item,mxitem)
          ist=1
          irow=INTGR(item(1),ist,ien)
          if (irow.eq.1) then
            ist=1
            aten(25,i)=getreal(item(2),ist,ien)
            goto 9115
          else if (irow.eq.2) then
            ist=1
            aten(26,i)=getreal(item(2),ist,ien)
            goto 9115
          else if (irow.eq.3) then
            ist=1
            aten(27,i)=getreal(item(2),ist,ien)
          end if 
        end if
        jomeg=jomeg+1
      end do
893   if(jomeg.ge.1) then
         rewind(lu)
         jomeg=0
      else
         readerror=.true.
         goto 99
      end if
c
99    continue
      close(lu)
c
      if (readerror) then
       write (iosl,*) ' getvroascf |error while reading G/A from ',name
       write (iosl,*) '       | No. of G/A sets expected: ',ipoldum
       write (iosl,*) '       | No. of G/A sets found:    ',jomeg
       write (iosl,*) '       | Check $TMPDIR/pol.out.(XX) for details'
       write (iosl,*) '       | (maybe dalton did not converge)'
       call errex('jomeg=/=ipoldum in gdalvroascf')
      end if
      call prmat(iosl,pol,ipoldum,8,'gdalvroascf: polarizability')
      call prmat(iosl,gtenlao,ipoldum,9,'gdalvroascf: G/LAO tensor')
      call prmat(iosl,gtenao,ipoldum,9,'gdalvroascf: G/AO tensor')
      call prmat(iosl,aten,ipoldum,27,'gdalvroascf: A tensor')
      call flush(iosl)
      return
c
      end



