CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine islave
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
C re-written by J. Neugebauer, Uni Erlangen, 2003
CCH modified by C. Herrmann, Uni Bonn, 02/2005 (intonly tool)
CCH modified by C. Herrmann, Uni Jena 04/05 (ADF interface)
CCH modified by C. Herrmann, Uni Jena 05/05 (Gaussian interface)
C>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      INCLUDE 'defs.h'
      INCLUDE 'objects.h'
      INCLUDE 'comm.h'
      INCLUDE 'param.h'  
      INTEGER l,ibuf,info,mbuf,ierr,irc,xeq,now,w,ns,lfilen
      INTEGER intgr,iclean,icleanl,idalmw,nfex,mcharge,ir1
C#    INTEGER st(MPI_STATUS_SIZE)
C#    CHARACTER*(MPI_MAX_PROCESSOR_NAME) mpiname
      INTEGER*4 iready,iwhat,kvers
      logical snffast,udalinp
      CHARACTER*255 b1,b2,filename
      character*80 dalmw
      CHARACTER*40 mynode,pnode
      character*10 calctype
      external nfex
      INCLUDE 'VERSION.h'
      real*8 normalmode(maxmode,maxatoms*3),freq(maxmode)
      integer intonly,nummodes,i,j
**
** slave processes
**
      ns=mxwrk
      isuhf=0
      ridft=0

* receive tempdir, jobdir, parent node name, current node name from master

C#      CALL MPI_GET_PROCESSOR_NAME(mpiname,l,info)
C#      CALL mpierr('MPI_GET_PROCESSOR_NAME','islave',info)
C#      CALL clean(mynode)
C#      mynode=mpiname(1:l)

        CALL pgetstr('islave: logdir',logdir,tid0,255,401,info)
        WRITE (iosl,*) 'islave: logdir=',logdir
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        CALL slen(logdir,ll)
        CALL secs(now)
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        CALL augnum(filename,logdir(1:ll)//'dclog.',now)
        CALL slen(logdir,ll)
        OPEN (unit=iosl,file=filename,STATUS='UNKNOWN')
        WRITE (iosl,*) '>>> snfdc slave log file for tid ',mytid
        WRITE (iosl,*) version
        CALL pgetstr('islave: progdir',progdir,tid0,255,402,info)
        CALL pgetstr('islave: arpath',arpath,tid0,255,403,info)
        CALL pgetstr('islave: masterid',masterid,tid0,255,404,info)
        CALL pgetstr('islave: tmpnode',b1,tid0,255,405,info)
        CALL pgetstr('islave: mydir',mydir,tid0,255,406,info)
        CALL pgetstr('islave: pnode',pnode,tid0,40,407,info)
        WRITE (iosl,*) 'islave: progdir=',progdir
        CALL flush(iosl)
C#      CALL pputstr('islave: mynode',mynode,tid0,40,408,info)
C//SKIPC#1
        CALL pgetstr('islave: mynode',mynode,tid0,40,408,info)
        CALL slen(b1,lt)
        CALL slen(mydir,lm)
        CALL slen(arpath,lar)
        CALL slen(progdir,lb)
        CALL slen(masterid,li)
CMR010504 the following line has been changed because it did not work in Oslo with MPI
CMR010504C#      now=10*now+mytid
C#      now=now+mytid

        CALL memmgr(1024 ,'memdbg',0,0,iosl)
        CALL memmgr(memini,'init',is,1,ns)
        CALL clean(b2)
        CALL fdate(b2)
        WRITE (iosl,*) b2(1:40)
        CALL flush(iosl)
        WRITE (iosl,*) 'TMPDIR=',b1(1:lt)
        WRITE (iosl,*) 'LOGDIR=',logdir(1:ll)
CBAH the brain-damaged pgf90 cannot write a string of length 0 without
CBAH crashing the program ...
        IF (lb.GT.0) WRITE (iosl,*) 'PROGDIR=',progdir(1:lb)
        WRITE (iosl,*) 'MYDIR =',mydir(1:lm)
        WRITE (iosl,*) 'MYNODE=',mynode
        WRITE (iosl,*) 'PNODE =',pnode
        CALL augnum(tempdir,b1(1:lt)//'/TMP',now)
        CALL slen(tempdir,lt)
        WRITE (iosl,*) 'PE0 TID=',tid0
        CALL flush(iosl)
        info=xeq('mkdir '//tempdir(1:lt))
        if(info.ne.0) then
          write(iosl,'(2a)') '** islave: cannot make directory: ',
     *      tempdir(1:lt)
          call flush(iosl)
          call errex('cannot create directory on slave node')
        end if
        info=0

*-------------------------------
* copy and read snf_control file
*-------------------------------
        WRITE (iosl,*) 'islave: waiting for <snf_control>'
        CALL flush(iosl)
C&      WRITE (iosl,*) 'get snf_control from ',mynode
C&      CALL getfile('snf_control',mynode,pnode,info)
C&      WRITE (iosl,*) 'return form getfile, info=',info
C&      call flush(iosl)
C//SKIPC&1
        CALL gfile('snf_control',tid0,info)
        call rscontrol(tempdir(1:lt)//'/snf_control',progno,calcno,ipol,
     *  omeg,snffast,iclean,icleanl,naus,mxomeg,cstep,idbg)

        CALL flush(iosl)

*--------------------------------------
* Turbomole: copy and read control file
*--------------------------------------
        if(progno.eq.1) then
C&        call getfile('control',mynode,pnode,info)
C//SKIPC&1
          call gfile('control',tid0,info)
          call rcontrol(tempdir(1:lt)//'/control',rpast,smult,isuhf,
     *     natoms,idbg)
*----------------------------------------
* Dalton: copy and read molecule.mol file
*----------------------------------------
        else if(progno.eq.2) then
C&        call getfile('molecule.mol',mynode,pnode,info)
C//SKIPC&1
          call gfile('molecule.mol',tid0,info)
          ir1=48
          open(ir1,file=tempdir(1:lt)//'/molecule.mol')
          call rbdalmol(natoms,ir1,mcharge)
          close(ir1)
*----------------------------------------
* Gaussian: copy and read gaussian.com file
*----------------------------------------
        else if(progno.eq.3) then
          call getfile('gaussian.com',mynode,pnode,info)
C//SKIPC&1
          call gfile('gaussian.com',tid0,info)
          call rgauss(tempdir(1:lt)//'/gaussian.com',natoms)
*----------------------------------------
* ADF: copy and read adf.in file
*----------------------------------------
        else if(progno.eq.4) then
C&        call getfile('adf.in',mynode,pnode,info)
C//SKIPC&1
          call gfile('adf.in',tid0,info)
          call radf(tempdir(1:lt)//'/adf.in',natoms)
        end if

*-----------------------------------------------------------------
* input parameters determined -> copy program-specific input files
* okok contains a "1" for every file to be copied, e.g.,
* 4 files = "1111"
*-----------------------------------------------------------------

        write(iosl,*) 'natoms = ', natoms
        call rscontrol2(normalmode,nummodes,intonly,freq,
     *  mydir(1:lm)//'/snf_control',iosl) 
        write(iosl,*) 'NMODE IN ISLAVE 1'
        write(iosl,*) 'nummodes = ', nummodes
        write(iosl,*) 'natoms = ', natoms
        do i = 1,nummodes
        do j = 1,natoms*3
          write(iosl,*) normalmode(i,j)
        end do
        end do

        okok=nfex(progno,calcno,isuhf)
        write(iosl,*) 'okok: ',okok
        call flush(iosl)
        if(okok.le.0) call errex('islave | invalid okok value')
        call calc_type(progno,calcno,calctype)

*------------------------
* Turbomole: coord, basis
*------------------------
        if(progno.eq.1) then
C&        call getfile('coord',mynode,pnode,info)
C//SKIPC&1
          call gfile('coord',tid0,info)
C&        call getfile('basis',mynode,pnode,info)
C//SKIPC&1
          call gfile('basis',tid0,info)
*--------------------------------------
* Turbomole: rks/rhf : mos
*            uks/uhf : alpha,beta
*--------------------------------------
          if (isuhf.EQ.0) THEN
C&          call getfile('mos',mynode,pnode,info)
C//SKIPC&1
            call gfile('mos',tid0,info)
          else
C&          call getfile('alpha',mynode,pnode,info)
C&          call getfile('beta',mynode,pnode,info)
C//SKIPC&2
            call gfile('alpha',tid0,info)
            call gfile('beta',tid0,info)
          end if
*------------------------------------------
* Turbomole: ridft/rimp2 ? -> copy auxbasis
*------------------------------------------
          if(index(calctype,'RI').ne.0) ridft=1
          if(ridft.gt.0) then
C&          call getfile('auxbasis',mynode,pnode,info)
C//SKIPC&1
            call gfile('auxbasis',tid0,info)
          endif
*-----------------------------------
* Dalton: molecule.dal, molecule.mol
*-----------------------------------
        else if(progno.eq.2) then
C&        call getfile('molecule.dal',mynode,pnode,info)
C//SKIPC&1
          call gfile('molecule.dal',tid0,info)
*------------------------------------------
* Dalton: MP2/SOPPA: 2 .dal files necessary
*------------------------------------------
          if(index(calctype,'SOPPA').ne.0) then
C&          call getfile('molecule.dal.B',mynode,pnode,info)
C//SKIPC&1
            call gfile('molecule.dal.B',tid0,info)
          end if
*-----------------------------------
* Gaussian: no further files needed
*-----------------------------------
        else if(progno.eq.3) then
          continue
*-----------------------------------
* ADF: no further files needed
*-----------------------------------
        else if(progno.eq.4) then
          continue
        else
          call errex('program type not implemented')
        end if
        call flush(iosl)

*----------------------------------------------------
* backup MO- and coord- files
*----------------------------------------------------
        if (info.eq.okok) then
          if(progno.eq.1) then
            if (isuhf.EQ.0) then
              call clean(b1)
              b1=tempdir(1:lt)//'/mos'
              call llen(b1,l)
              irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
            else
              call clean(b1)
              b1=tempdir(1:lt)//'/alpha'
              call llen(b1,l)
              irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
              call clean(b1)
              b1=tempdir(1:lt)//'/beta'
              call llen(b1,l)
              irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
            end if
            call clean(b1)
            b1=tempdir(1:lt)//'/coord'
            call llen(b1,l)
            irc=xeq('mv '//b1(1:l)//' '//b1(1:l)//'.ori')
          else if(progno.eq.2) then
            call clean(b1)
            b1=tempdir(1:lt)//'/molecule.mol'
            call llen(b1,l)
            irc=xeq('mv '//b1(1:l)//' '//b1(1:l)//'.ori')
          else if(progno.eq.3) then
            call clean(b1)
            b1=tempdir(1:lt)//'/gaussian.com'
            call llen(b1,l)
            irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
          else if(progno.eq.4) then
            call clean(b1)
            b1=tempdir(1:lt)//'/adf.in'
            call llen(b1,l)
            irc=xeq('cp '//b1(1:l)//' '//b1(1:l)//'.ori')
          end if
        end if
        write (iosl,*) '>>> input files copied, results is ',info
        call flush(iosl)
        iready=info
        write (b1,'(I5)') ivers
C@      call mnotify(9,mytid,iready,b1,5)

*---------------
* node ready ???  
*---------------
C#      w=MPI_COMM_WORLD
C:      CALL MPI_SSEND(iready,1,MPI_INTEGER,tid0,407,w,info)
C//SKIPC:1
C#      CALL MPI_SEND(iready,1,MPI_INTEGER,tid0,407,w,info)
C#      CALL mpierr('MPI_(S)SEND iready','islave',info)
C:      CALL MPI_SSEND(ivers,1,MPI_INTEGER,tid0,408,w,info)
C//SKIPC:1
C#      CALL MPI_SEND(ivers,1,MPI_INTEGER,tid0,408,w,info)
C#      CALL mpierr('MPI_(S)SEND ivers','islave',info)
C#      IF (iready.NE.okok) THEN
C#        WRITE (iosl,*) '>>> calling termcomm: iready=',iready
C#        CALL flush(iosl)
C#        CALL termcomm('islave: not ready')
C#      ENDIF

C#52    CALL MPI_RECV(iwhat,1,MPI_INTEGER,tid0,409,w,st,info)
C#      CALL mpierr('MPI_RECV iwhat','islave',info)
C#      IF (iwhat.EQ.1) CALL cslave(normalmode,freq,intonly,nummodes)
C#      IF (iwhat.GE.0) GOTO 52

C//SKIPC#
        call PVMFINITSEND(PVMDATADEFAULT,MBUF)
        call PVMFPACK(INTEGER4, iready, 1, 1, INFO )
        if (info.NE.0) CALL pvmfperror('pack iready',info)
        kvers=ivers
        call PVMFPACK(INTEGER4, kvers, 1, 1, INFO )
        if (info.NE.0) CALL pvmfperror('pack ivers',info)
        call PVMFSEND( tid0, 0, INFO )
        if (info.NE.0) CALL pvmfperror('send iready',info)
        if (iready.NE.okok) THEN
          write (iosl,*) '>>> calling termcomm: iready=',iready
          call flush(iosl)
          call termcomm('islave: not ready')
        end if

*---------------------------------------------------------
* still missing: remove old scratch and restart files
*                of single point calculations
*---------------------------------------------------------
*----------------
* receive command
*----------------
42      continue 
        CALL PVMFRECV(tid0,0,ibuf)
        CALL PVMFUNPACK(INTEGER4,iwhat,1,1,info)
        WRITE (iosl,*) '>>> iwhat =',iwhat
        CALL flush(iosl)
        WRITE (iosl,*) 'islave: ',tempdir(1:lt)
        if(iwhat.eq.1) call cslave(normalmode,freq,intonly,nummodes)
        write(iosl,*) ' back from cslave, iwhat = ',iwhat
        CALL flush(iosl)
CDBG        if(intonly.ne.1) then
        if(iwhat.gt.-1) goto 42
CDBG        end if
C//END
99    CONTINUE
      WRITE (iosl,*) '>>> finishing'
      CALL flush(iosl)
C@    info=xeq('rm -rf '//tempdir(1:lt))
      WRITE (iosl,*) 'slave tid ',mytid,' stopping.'
      CLOSE (UNIT=iosl)
      if(icleanl.eq.1) then
        CALL slen(filename,lfilen)
        info=xeq('rm '//filename(1:lfilen))
      end if
      IF(iclean.eq.1) THEN
        info=xeq('rm -r '//tempdir(1:lt))
      END IF
      RETURN
      END
