CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine rcontrol(tempname,rpast,smult,isuhf,natoms,idbg)
*-------------------------------------------------------------------
* read <snf_control> file
* only Turbomole-specific information is read from <control>
*-------------------------------------------------------------------
      implicit none
      integer lu,idbg,rpast,smult,isuhf,natoms,n
      real*8 xx(2)
      external getreal
      character*(*) tempname
      character*20 a20
      integer mxitem,i,naus
      parameter (mxitem=12)
      character*255 b1
      character*255 item(mxitem)

      lu=1
C@    WRITE (idbg,*) 'reading <control> from ',tempname
      OPEN (UNIT=lu,FILE=tempname,STATUS='UNKNOWN')
      isuhf=0
      rpast=0
      smult=0

1     READ (lu,'(A)',END=999) b1
      if(index(b1,'$soes').ne.0) then
        read (lu,'(A)',end=999) b1
        call split(b1,item,mxitem)
        read(item(2),*,err=999,end=999) rpast
      else if(index(b1,'$scfinstab').ne.0) then
        if(index(b1,'rpas').ne.0) then
           smult=1
        else if(index(b1,'ciss').ne.0) then
           smult=1
        else if(index(b1,'rpat').ne.0) then
           smult=3
        else if(index(b1,'cist').ne.0) then
           smult=3
        end if
      else if(index(b1,'$uhf').ne.0) then
        isuhf=1
      else if(index(b1,'natoms=').ne.0) then
       write(*,*) 'found natoms in control:'
       write(*,*) b1
       a20=b1
       call readl(20,a20,xx,n)
       natoms=int(xx(1))
      end if
      goto 1
900   call errex('error while reading control')
999   close (UNIT=lu)
      return
      end

