CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine wrestart(vmach,dip,pol,gtenlao,gtenao,aten,gra,istepfl,
     *                    intonly,nummodes)
CMR   modified by M. Reiher for VROA, Uni Erlangen, June 2003
CCH   modified by C. Herrmann, Uni Bonn, 02/2005
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      CHARACTER*255 form
      INTEGER istepfl(*)
      REAL*8 dip(*)
      REAL*8 pol(mxomeg,*)
      REAL*8 gra(*)
      REAL*8 vmach(*)
      INTEGER i,j,k,in1,ires,imin,inul,ione,jomeg
      CHARACTER*24 date

      REAL*8 gtenlao(mxomeg,*),gtenao(mxomeg,*),aten(mxomeg,*)
      LOGICAL vroaflag
      INTEGER ipoldum
      integer intonly,nummodes,l,numi,numj
      character*4 stepchar

      INCLUDE 'VERSION.h'
      DATA form /'(4D20.10)'/

      in1=88
c
      vroaflag=.false.
      ipoldum=ipol
      IF (ipol-1000.ge.0) THEN
        vroaflag=.true.
        ipoldum=ipol-1000
        IF (ipoldum.eq.0) ipoldum=1
      ENDIF
c
      CALL howmany(inul,ione,i,istepfl)
      OPEN (unit=in1,file=restart,STATUS='UNKNOWN')
      WRITE (in1,'(A)') title
      WRITE (in1,'(A)') form
      WRITE (in1,'(14I5)') ivers,progno,calcno,ipol,nvar,
     * naus,nummodes,inul,ione
* ipol           number of sets of polarizabilities
*                (for different frequencies)
* if(ipol.eq.0) => no Raman calculation
* inul           number of  0 step entries ('pending')
* ione           numner of  1 step entries ('done')
      WRITE (in1,form) cstep
      WRITE (in1,'(A)') mydir(1:lm)
      WRITE (in1,'(A)') tempdir(1:lm)
CCH in order to avoid nearly redundant code in intonly version, 
cch numi, numj and stepchar are introduced - numj in standard version is 
CCH 3* numj in intonly version since 3 elongations per atom and ...
CCH are needed instead of only one per normal mode
      if(intonly.eq.1) then
        numi=nummodes
        numj=naus
        stepchar='mode'
      else
        numi=natoms
        numj=naus*3
        stepchar='atom'
      end if 
      DO i=1,numi
       j=(i-1)*numj
       WRITE (in1,'(24I3)') i,(istepfl(k),k=j+1,j+numj)
       WRITE (in1,'(12A8)') (vmach(k),k=j+1,j+numj)
      ENDDO
      DO i=1,numi
       WRITE (in1,*) 'dipoles '//stepchar,i
       j=(i-1)*numj*3
       WRITE (in1,form) (dip(k),k=j+1,j+numj*3)
      ENDDO
      if(intonly.eq.0) then
        DO i=1,natoms
         WRITE (in1,*) 'gradients atom',i
         j=(i-1)*3*naus*nvar
         WRITE (in1,form) (gra(k),k=j+1,j+naus*nvar*3)
        ENDDO
      end if
*
* polarizabilities
*
      if (.not.vroaflag) then
       DO jomeg=1,ipol
        DO i=1,numi
         j=(i-1)*numj*8
         WRITE (in1,'(a22,i8,a13,d20.10)') ' polarizabilities '//
     *         stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (pol(jomeg,k),k=j+1,j+numj*8)
        ENDDO
       ENDDO
      else
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*8
         WRITE (in1,'(a22,i8,a13,d20.10)') ' polarizabilities '
     *         //stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (pol(jomeg,k),k=j+1,j+numj*8)
        ENDDO
       ENDDO
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*9
         WRITE (in1,'(a22,i8,a13,d20.10)') ' G tensors (LAO) '//
     *         stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (gtenlao(jomeg,k),k=j+1,j+numj*9)
        ENDDO
       ENDDO
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*9
         WRITE (in1,'(a22,i8,a13,d20.10)') ' G tensors (AO) '//
     *          stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (gtenao(jomeg,k),k=j+1,j+numj*9)
        ENDDO
       ENDDO
       DO jomeg=1,ipoldum
        DO i=1,numi
         j=(i-1)*numj*27
         WRITE (in1,'(a22,i8,a13,d20.10)') ' A tensors '//
     *          stepchar,i,' frequency = ',omeg(jomeg)
         WRITE (in1,form) (aten(jomeg,k),k=j+1,j+numj*27)
        ENDDO
       ENDDO
      endif

      CALL fdate(date)
      WRITE (in1,'(A)') date
**    WRITE (in1,'(A8,I8)') (vmach(k),is(pti+k-1),k=1,nnode)
      CLOSE (in1)
      RETURN
      END

      SUBROUTINE rrestart(vmach,dip,pol,gtenlao,gtenao,aten,
     *                    gra,istepfl,isum,intonly,nummodes)
CMR   modified by M. Reiher for VROA, Uni Erlangen, June 2003
CCH   modified by C. Herrmann for intensities only mode, 02/2005
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INTEGER istepfl(*)
      CHARACTER*255 form,buf
      INTEGER i,j,k,isum,jvers,iaus,in1,inul,ione
      INTEGER jomeg,komeg,mprogno,mcalcno,mpol
      LOGICAL ex
      REAL*8 pstep
      REAL*8 dip(*),vmach(*)
      REAL*8 pol(mxomeg,*)
      REAL*8 gra(*)

      REAL*8 gtenlao(mxomeg,*),gtenao(mxomeg,*),aten(mxomeg,*)
      LOGICAL vroaflag
      INTEGER ipoldum
      integer intonly,nummodes,l,numi, numj
      character*4 stepchar

      INCLUDE 'VERSION.h'

      vroaflag=.false.
      intonly=0

      in1=88
      INQUIRE (FILE=restart,EXIST=ex)
      IF (.NOT.ex) RETURN

      OPEN (UNIT=in1,FILE=restart,STATUS='OLD')
      rewind(in1)
      READ(in1,'(A)')
      READ(in1,'(A)') form
      READ(in1,'(14I5)') jvers,mprogno,mcalcno,mpol,nvar,
     * iaus,nummodes,inul,ione
      if(nummodes.ne.0) intonly = 1

CCH in order to avoid nearly redundant code in intonly version,
cch numi, numj and stepchar are introduced
      if(intonly.eq.1) then
        numi=nummodes
        numj=naus
        stepchar='mode'
      else
        numi=natoms
        numj=naus*3
        stepchar='atom'
      end if

      ipoldum=mpol
      if (mpol-1000.ge.0) then
        vroaflag=.true.
        ipoldum=mpol-1000
        if (ipoldum.eq.0) ipoldum=1
      endif

      i=ivers/10
      j=jvers/10
      IF (jvers.LT.170) THEN
       WRITE (*,*) '****** incompatible versions '
       WRITE (*,*) '****** version on restart file :',jvers
       WRITE (*,*) '****** current program version :',ivers
       CALL errex('incompatible restart file')
      ENDIF
      IF (calcno.NE.mcalcno) THEN
       WRITE (*,*) '****** <control> file has been changed:'
       WRITE (*,*) '****** calculation type on restart file :',mcalcno
       WRITE (*,*) '****** current program mode :',calcno
       CALL errex('incompatible restart file')
      ENDIF
      IF (progno.NE.mprogno) THEN
       WRITE (*,*) '****** <control> file has been changed:'
       WRITE (*,*) '****** program no. on restart file :',mprogno
       WRITE (*,*) '****** current program mode :',progno
       CALL errex('incompatible restart file')
      ENDIF
      IF (ipol.NE.mpol) THEN
       WRITE (*,*) '****** <control> file has been changed:'
       WRITE (*,*) '****** ipol on restart file :',mpol
       WRITE (*,*) '****** current program ipol from snf_control:',ipol
       CALL errex('incompatible restart file')
      ENDIF
      IF (naus.NE.iaus) THEN
       WRITE (*,*) '****** <control> file has been changed:'
       WRITE (*,*) '****** restart file is using ',iaus,' point formula'
       WRITE (*,*) '****** current program is using ',naus,
     * ' point formula'
       CALL errex('incompatible restart file')
      ENDIF
      READ (in1,form) pstep
      IF (DABS(cstep-pstep).GT.1.D-6) THEN
       WRITE (*,*) '****** cstep has been changed:'
       WRITE (*,*) '****** cstep on restart file     :',pstep
       WRITE (*,*) '****** current program cstepmode :',cstep
       CALL errex('incompatible restart file')
      ENDIF
      READ (in1,'(A)') 
      READ (in1,'(A)') 
      DO i=1,numi
       j=(i-1)*numj
       READ (in1,'(24I3)') k,(istepfl(k),k=j+1,j+numj)
       READ (in1,'(12A8)') (vmach(k),k=j+1,j+numj)
      ENDDO
      DO i=1,numi
       READ (in1,'(A)')
       j=(i-1)*numj*3
       READ (in1,form) (dip(k),k=j+1,j+numj*3)
      ENDDO
      if(intonly.eq.0) then
        DO i=1,natoms
         READ (in1,'(A)')
         j=(i-1)*3*naus*nvar
         READ (in1,form) (gra(k),k=j+1,j+naus*nvar*3)
        ENDDO
      end if
*
* polarizabilities
*
      if (.not.vroaflag) then
       DO jomeg=1,ipol
        DO i=1,numi
          j=(i-1)*numj*8
          READ (in1,'(A)')
          READ (in1,form) (pol(jomeg,k),k=j+1,j+numj*8)
        ENDDO
       ENDDO
      else
       DO jomeg=1,ipoldum
        DO i=1,numi
          j=(i-1)*numj*8
          READ (in1,'(A)')
          READ (in1,form) (pol(jomeg,k),k=j+1,j+numj*8)
        ENDDO
       ENDDO
       DO jomeg=1,ipoldum
        DO i=1,numi
          j=(i-1)*numj*9
          READ (in1,'(A)')
          READ (in1,form) (gtenlao(jomeg,k),k=j+1,j+numj*9)
        ENDDO
       ENDDO
       DO jomeg=1,ipoldum
        DO i=1,numi
          j=(i-1)*numj*9
          READ (in1,'(A)')
          READ (in1,form) (gtenao(jomeg,k),k=j+1,j+numj*9)
        ENDDO
       ENDDO
       DO jomeg=1,ipoldum
        DO i=1,numi
          j=(i-1)*numj*27
          READ (in1,'(A)')
          READ (in1,form) (aten(jomeg,k),k=j+1,j+numj*27)
        ENDDO
       ENDDO
      endif
 
      isum=0
      do i=1,nstept
         if(istepfl(i).eq.-1)istepfl(i)=0 
         isum=isum+istepfl(i) 
      enddo

      write(*,*)'% done yet',100.*float(isum)/float(nstept)

      close (in1)
      return
      end
